// Performance Data Tool Javascript and jQuery include file
// Copyright 2016-05-05 Troy Lea aka Box293

// This makes an ajax call synchronous
function performancedatatool_ajaxSetup() {
	// I want all ajax calls to be performed synchronously
	$.ajaxSetup({
		async: false,
		cache: false,
		}); // End $.ajaxSetup({
	} // End function performancedatatool_ajaxSetup() {


function performancedatatool_ToggleMenu(a) {
	// hide all menu elements 
   	$('.performancedatatool-togglediv').hide(); 
	// reset the last item that was selected
	$('.performancedatatool-menuheading2').addClass("performancedatatool-menuheading1").removeClass("performancedatatool-menuheading2");
	// show the selected menu element
	$('#' + a).show(); 
	// Style the currently selected menu item
	$('#id-' + a).addClass("performancedatatool-menuheading2").removeClass("performancedatatool-menuheading1");
	} // End function performancedatatool_ToggleMenu(a) {


function performancedatatool_ToggleMenuSub(a) {
	// hide all menu elements 
   	$('.performancedatatool-togglediv-sub').hide(); 
	// reset the last item that was selected
	$('.performancedatatool-menuheading-sub2').addClass("performancedatatool-menuheading-sub1").removeClass("performancedatatool-menuheading-sub2");
	// show the selected menu element
	$('#' + a).show(); 
	// Style the currently selected menu item
	$('#id-' + a).addClass("performancedatatool-menuheading-sub2").removeClass("performancedatatool-menuheading-sub1");
	} // End function performancedatatool_ToggleMenuSub(a) {


function performancedatatool_ToggleMenuSubSub(a) {
	var options = a.split(',');
	// hide all menu elements 
   	$('.performancedatatool-togglediv-sub-' + options[1]).hide(); 
	// reset the last item that was selected
	$('.performancedatatool-menuheading-sub-' +  options[1] + '2').addClass('performancedatatool-menuheading-sub-' +  options[1] + '1').removeClass('performancedatatool-menuheading-sub-' +  options[1] + '2');
	// show the selected menu element
	$('#' +  options[0]).show(); 
	// Style the currently selected menu item
	$('#id-' + options[0]).addClass('performancedatatool-menuheading-sub-' +  options[1] + '2').removeClass('performancedatatool-menuheading-sub-' +  options[1] + '1');
	} // End function performancedatatool_ToggleMenuSubSub(a) {

	
function performancedatatool_toggleMe(a) {
	$('#'+ a).slideToggle();
	} // End function performancedatatool_toggleMe(a) {


function performancedatatool_hide_show_table(id) {
	var hide_show_button = '#id_performancedatatool_button_hide_show_table_' + id;
	var hide_show_value = $(hide_show_button).val();
	//alert('hide_show_value ' + hide_show_value);
	if (hide_show_value == 'Hide Table') {
		$('#performancedatatool-' + id + '-table').hide();
		$(hide_show_button).val('Show Table');
		} // End if (hide_show_value == 'Hide Table') {
	else if (hide_show_value == 'Show Table') {
		$('#performancedatatool-' + id + '-table').show();
		$(hide_show_button).val('Hide Table');
		} // End else if (hide_show_value == 'Show Table') {
	} // End function performancedatatool_hide_show_table(id) {

	
function performancedatatool_toggleAll(a) {
	var topics = a.split(':');
	var toggleAllText = $('#expand_collapse').text();
	for (var i=0;i<topics.length;i++) {
		if (toggleAllText == 'Expand All') {
			$('#' + topics[i]).show();
			} // End if (toggleAllText == 'Expand All') {
		else if (toggleAllText == 'Collapse All') {
			$('#' + topics[i]).hide();
			} // End else if (toggleAllText == 'Collapse All') {
		} // End for (var i=0;i<topics.length;i++) {
	if (toggleAllText == 'Expand All') {
		$('#expand_collapse').text('Collapse All');
		} // End if (toggleAllText == 'Expand All') {
	else if (toggleAllText == 'Collapse All') {
		$('#expand_collapse').text('Expand All');
		} // End else if (toggleAllText == 'Collapse All') {
	} // End function performancedatatool_toggleAll(a) {


function performancedatatoolToggleCheckbox(a) {
	//window.alert("value is: " + a);
	if ($('#'+ a).is(':checked')) {
		$(".performancedatatool-checkbox").attr('checked', true);
		} // End if ($('#'+ a).is(':checked')) {
	else {
		$(".performancedatatool-checkbox").attr('checked', false);
		} // End else {
	} // End function performancedatatoolToggleCheckbox(a) {

	
function performancedatatool_SortTable(input_request) {
	input_request = input_request.split(",");
	//alert('input_request = ' + input_request);

	var TableID = input_request[0];
	//alert('TableID = ' + TableID);
	
	var type = input_request[1];
	//alert('type = ' + type);
	
	switch (type) {
		case 'browse':
		case 'merge':
			//alert('case = ' + type);
			$('#' + TableID).tablesorter( {sortList: [[0,0], [1,0]], widgets: ['zebra']} ).bind('sortEnd', function(){$('#' + TableID).trigger("applyWidgets")});
			break; // End case 'browse': 'merge':
	
		case 'delete':
		case 'merge-list':
			$('#' + TableID).tablesorter( {
				headers: {
					// disable sorting of the first column (we start counting at zero)
					0: {
						// disable it by setting the property sorter to false
						sorter: false
						}
					},
				sortList: [[1,0], [2,0]], widgets: ['zebra']
				} ).bind('sortEnd', function(){$('#' + TableID).trigger("applyWidgets")});
			break; // End case 'delete': 'merge-list': 
		
		case 'merge-source':
		case 'merge-destination':
			// Get the merge type selected
			var merge_type_selected = $('#id_merge option:selected').val();
			//alert('Merge Type = ' + merge_type_selected);
			switch (merge_type_selected) {
				case 'specific':
					$('#' + TableID).tablesorter( {
						headers: {
							// disable sorting of the first column (we start counting at zero)
							0: {
								// disable it by setting the property sorter to false
								sorter: false
								}
							},
						sortList: [[1,0], [2,0]], widgets: ['zebra']
						} ).bind('sortEnd', function(){$('#' + TableID).trigger("applyWidgets")});		
					break; // End case 'specific':
				
				case 'folder':
				case 'structure':
					$('#' + TableID).tablesorter( {sortList: [[0,0], [1,0]], widgets: ['zebra']} ).bind('sortEnd', function(){$('#' + TableID).trigger("applyWidgets")});
					break; // End case 'folder': 'structure':
				} // End switch (merge_type_selected) {
			break; // End case 'merge-source': 'merge-destination':
		
		case 'DisplayContent':
			$('#' + TableID).tablesorter( {sortList: [[0,1]], widgets: ['zebra']} ).bind('sortEnd', function(){$('#' + TableID).trigger("applyWidgets")});
			break; // End case 'DisplayContent':
	
		} // End switch (type) {
	//alert('it should be sorted');
	} // End function performancedatatool_SortTable(input_request) {


function performancedatatool_misc(input_request) {
	input_request = input_request.split(",");
	// Get the request
	var request = input_request[0];
	// Get the type
	var type = input_request[1];
	if (request == 'delete') {
		// Define the DIV ID we are going to load
		var div_id = '#performancedatatool-action-' + request;
		// Load the DIV
		$(div_id).load(
			'/nagiosxi/includes/components/performancedatatool/performance_data_tool_misc.php',
			{
				'request'	: request
				}
			); // End $(div_id).load(
		} // End if (request == 'delete') {
	else {
		// Define the DIV ID we are going to load
		var div_id = '#performancedatatool-' + request + '-' + type;
		// Load the DIV
		$(div_id).load(
			'/nagiosxi/includes/components/performancedatatool/performance_data_tool_misc.php',
			{
				'request'	: request,
				'type'		: type,
				}
			);	// End $(div_id).load(
		} // End else {
	//alert('END performancedatatool_misc(input_request)');
	} // End function performancedatatool_misc(request, type) {



function performancedatatool_merge_type(settings) {
	// Define the test variables
	var selection_test = 0;
	
	// Get the merge type selected
	var merge_type_selected = $('#id_merge option:selected').val();
	//alert('Merge Type = ' + merge_type_selected);
	
	// Need to check if a merge type was selected
	if (merge_type_selected == '') {
		alert('You did not select a merge type!');
		} // End if (merge_type_selected == '') {
	else {
		performancedatatool_ajaxSetup();
		$('#performancedatatool-merge-list-action').load(
			'/nagiosxi/includes/components/performancedatatool/performance_data_tool_misc.php',
			{
				'request'				: 'merge_action_list',
				'merge_type_selected'	: 'merge_list_' + merge_type_selected,
				}
			); // End $('#performancedatatool-merge-list-action').load(
		
		// Need to check if a source folder is already selected
		var folder_array_source = $('#id_all_host_folders_merge-source option:selected').val();
		//alert('folder_array_source = ' + folder_array_source);
		if (folder_array_source != '') {
			performancedatatool_draw_table('merge-source')
			} // End if (folder_array_source != '') {
		
		// Need to check if a destination folder is already selected
		var folder_array_destination = $('#id_all_host_folders_merge-destination option:selected').val();
		//alert('folder_array_destination = ' + folder_array_destination);
		if (folder_array_destination != '') {
			performancedatatool_draw_table('merge-destination')
			} // End if (folder_array_destination != '') {
		
		switch (merge_type_selected) {
			case 'specific':
				$('#performancedatatool-merge-structure-no-config').hide();
				$('#performancedatatool-merge-source').show();
				$('#performancedatatool-merge-structure-source').hide();
				$('#performancedatatool-merge-destination').show();
				$('#performancedatatool-merge-structure-destination').hide();
				$('#performancedatatool-merge-list-match-type').hide();
				$('#performancedatatool-merge-list-action').show();
				$('#performancedatatool-merge-list').show();
				break; // End case 'specific':
				
			case 'folder':
				$('#performancedatatool-merge-structure-no-config').hide();
				$('#performancedatatool-merge-source').show();
				$('#performancedatatool-merge-structure-source').hide();
				$('#performancedatatool-merge-destination').show();
				$('#performancedatatool-merge-structure-destination').hide();
				$('#performancedatatool-merge-list-match-type').show();
				$('#performancedatatool-merge-list-action').show();
				$('#performancedatatool-merge-list').show();
				break; // End case 'folder':
			
			case 'structure':
				if (settings == 'defined') {
					$('#performancedatatool-merge-structure-no-config').hide();
					$('#performancedatatool-merge-source').hide();
					performancedatatool_misc('structure-select,merge-source');
					$('#performancedatatool-merge-structure-source').show();
					$('#performancedatatool-merge-destination').hide();
					$('#performancedatatool-merge-structure-destination').show();
					$('#performancedatatool-merge-list-match-type').show();
					$('#performancedatatool-merge-list-action').show();
					$('#performancedatatool-merge-list').show();
					} // End if (settings == 'defined') {
				else {
					$('#performancedatatool-merge-source').hide();
					$('#performancedatatool-merge-structure-source').hide();
					$('#performancedatatool-merge-destination').hide();
					$('#performancedatatool-merge-structure-destination').hide();
					$('#performancedatatool-merge-list-match-type').hide();
					$('#performancedatatool-merge-list-action').hide();
					$('#performancedatatool-merge-list').hide();
					$('#performancedatatool-merge-submit-button').hide();
					$('#performancedatatool-merge-structure-no-config').show();
					} // End else {
				break; // End case 'structure':
			} // End switch (merge_type_selected) {
		} // End else {
	} // End function performancedatatool_merge_type() {

	
function performancedatatool_draw_table(select_supplied_name) {
	//alert('select_supplied_name: ' + select_supplied_name);
	
	// Define the test variable
	var all_ok = 0;
		
	// Get the folder name selected
	var folder_array = $('#id_all_host_folders_' + select_supplied_name + ' option:selected').val();
	//alert('Selected Folder Array = ' + folder_array);
	
	// Need to check if nothing was selected
	if (folder_array == '') {
		alert('You need to select a Performance Data Host Folder');
		all_ok = 1;
		} // End if (folder_array == '') {
	else {
		var folder_selected = jQuery.parseJSON(decodeURIComponent(folder_array));
		var folder_name = folder_selected.folder_name;
		var folder_location = folder_selected.folder_location;
		var folder_type = folder_selected.folder_type;
		//alert('folder_name: ' + folder_name);
		//alert('folder_location: ' + folder_location);
		//alert('folder_type: ' + folder_type);
		} // End else {
	
	// Get the merge type selected
	var merge_type_selected = $('#id_merge option:selected').val();
	//alert('merge_type_selected: ' + merge_type_selected);
	
	// Define the DIV ID we are going to load
	var div_id = '#performancedatatool-' + select_supplied_name + '-table';
	//alert('div_id: ' + div_id);
	var div_throbber_id = '#performancedatatool-' + select_supplied_name + '-table-throbber';
	
	// Need to get the date filter selected
	var dateFilter = $('#id_date_filters_' + select_supplied_name + ' option:selected').val();
	//alert('dateFilter: ' + dateFilter);
	var div_date_filter_id = '#performancedatatool-date-filter-' + select_supplied_name;
	
	// Load performance_data_tool_draw_table.php
	if (all_ok == 0) {
		//alert('All OK');
		$(div_id).hide();
		$(div_throbber_id).show();
		$(div_date_filter_id).show();
		performancedatatool_ajaxSetup();
		$(div_id).load(
			'/nagiosxi/includes/components/performancedatatool/performance_data_tool_draw_table.php',
			{
				'folder_name'			: encodeURIComponent(folder_name),
				'folder_location'		: encodeURIComponent(folder_location),
				'folder_type'			: folder_type,
				'select_supplied_name'	: encodeURIComponent(select_supplied_name),
				'dateFilter'			: dateFilter,
				'merge_type_selected'	: merge_type_selected
				},
			function() {
				$(div_throbber_id).hide();
				$(div_id).show();
				} // End function() {
			); // End $(div_id).load(
		//alert('Table should appear now');
		var files_in_table = $('#id_performancedatatool_files_' + select_supplied_name).val();
		switch (select_supplied_name) {
			case 'browse':
			case 'merge-source':
			case 'merge-destination':
				var div_refresh_id = '#performancedatatool-refresh-table-' + select_supplied_name;
				$(div_refresh_id).show();
				break; // End case 'browse': 'merge-source': 'merge-destination':
			
			case 'delete':
				var div_refresh_id = '#performancedatatool-refresh-table-' + select_supplied_name;
				$(div_refresh_id).show();
				var div_action_id = '#performancedatatool-action-' + select_supplied_name;
				$(div_action_id).show();
				break; // End case 'delete':
			} // End switch (select_supplied_name) {
		
		// Determine if we hide or show the table filters and buttons
		var div_table_filters_id = '#performancedatatool-date-filter-' + select_supplied_name;
		var div_table_buttons_id = '#performancedatatool-refresh-table-' + select_supplied_name;
		if (files_in_table == 'no') {
			$(div_table_filters_id).hide();
			$(div_table_buttons_id).hide();
			} // End if (files_in_table == 'no') {
		else {
			$(div_table_filters_id).show();
			var hide_show_button = '#id_performancedatatool_button_hide_show_table_' + select_supplied_name;
			$(hide_show_button).val('Hide Table');
			$(div_table_buttons_id).show();
			} // End else {
		} // End if (all_ok == 0) {
	} // End function performancedatatool_draw_table(select_supplied_name) {

	
function performancedatatool_perform_action(action) {
	//alert('Action = ' + action);
	
	// Define the test variables
	var selection_test = 0;
	var all_ok = 0;
		
	// Get the action selected
	var action_selected = $('#id_action_' + action + ' option:selected').val();
	//alert('Action Selected = ' + action_selected);
	
	// Need to check if an action was selected
	if (action_selected == '') {
		alert('You did not select an action!');
		all_ok = 1;
		} // End if (action_selected == '') {
	else {
		switch (action) {
			case 'delete':
				switch (action_selected) {
					case 'delete_selected_items':
						// Define the array
						var delete_array = new Array();
						// Get any checked files
						$('input:checkbox.performancedatatool-checkbox').each(function () {
							if (this.checked) {
								// Create the nested array
								delete_array[selection_test] = new Array();
								var item_checked = jQuery.parseJSON(decodeURIComponent($(this).val()));
								//alert(item_checked.foldername);
								//alert(item_checked.filename);
								//alert(item_checked.folderlocation);
								// Add the items to the nested array
								delete_array[selection_test][0] = item_checked.foldername;
								delete_array[selection_test][1] = item_checked.filename;
								delete_array[selection_test][2] = item_checked.folderlocation;
								selection_test++;
								} // End if (this.checked) {
							}); // End $('input:checkbox.performancedatatool-checkbox').each(function () {
						//alert('delete_array = ' + delete_array);
						
						//alert('selection_test = ' + selection_test);
						// Need to check if nothing was selected
						if (selection_test == '0') {
							alert('You did not select any files!');
							all_ok = 1;
							} // Endif (selection_test == '0') {
						
						break; // End case 'delete_selected_items':
						
					case 'delete_folder':
						// Get the foldername_array selected
						var foldername_array = jQuery.parseJSON(decodeURIComponent($('#id_all_host_folders_' + action + ' option:selected').val()));
						//alert('foldername_array = ' + foldername_array);
						// Get the foldername
						var foldername = foldername_array.folder_name;
						//alert('foldername = ' + foldername);
						// Get the folderlocation
						var folderlocation = foldername_array.folder_location;
						//alert('folderlocation = ' + folderlocation);
						break; // End case 'delete_folder':
					} // End switch (action_selected) {
				break; // End case 'delete':
			
			case 'merge_list':
			case 'merge_list_specific':
			case 'merge_list_folder':
			case 'merge_list_structure':
				// Define the throbber div
				var div_throbber_id = '#performancedatatool-merge-list-table-throbber';
				// Define the merge list div
				var div_merge_list_id = '#performancedatatool-merge-list';
				// Hide the merge list
				$(div_merge_list_id).hide();
				// Show the throbber image
				$(div_throbber_id).show();
				// Message to be displayed for certain actions
				if (action_selected != 'clear') {
					alert('Please be patient.\n\nThe more files there are, the longer it will take to update the screen.'); 
					} // End if (action_selected != 'clear') {
				
				// Define if the match needs to be CaSe sEnSatIvE
				var match_type = $('input[name="merge_match_type"]:checked').val();
				//alert('match_type ' + match_type);
				
				switch (action_selected) {
					case 'add':
						// Get the merge source and check for a valid value
						if ($('input[name=merge_source]').length == 0) {
							alert('You did not select a SOURCE file');
							all_ok = 1;
							}
						else if (!$('input[name=merge_source]:checked').val()) {
							alert('You did not select a SOURCE file');
							all_ok = 1;
							}
						else {
							var merge_source = decodeURIComponent($('input[name=merge_source]:checked').val());
							//alert('merge_source: ' + merge_source);	
							}
						
						// Get the merge destination and check for a valid value
						if ($('input[name=merge_destination]').length == 0) {
							alert('You did not select a DESTINATION file');
							all_ok = 1;
							}
						else if (!$('input[name=merge_destination]:checked').val()) {
							alert('You did not select a DESTINATION file');
							all_ok = 1;
							}
						else {
							var merge_destination = decodeURIComponent($('input[name=merge_destination]:checked').val());
							//alert('merge_destination: ' + merge_destination);	
							}
						
						// Check to make sure that the source and destination are not the same file
						if ((merge_source !== undefined) && (merge_destination !== undefined)) {
							if (merge_source == merge_destination) {
								alert('The SOURCE and DESTINATION file CANNOT be the same');
								all_ok = 1;
								}
							}
						
						if (all_ok == 0) {
							var existing_array = $('input#id_performancedatatool_merge_list_array').val();
							//alert(existing_array);
							var existing_test = 0;
							
							// Define the array we will load onto the page
							var merge_list_array = new Array();
							var merge_list_counter = 0;
							
							// If the PHP message list array already exists we need to add these to the JavaScript array
							if (existing_array !== undefined) {
								// Decode and JSON the existing array
								existing_array = jQuery.parseJSON(decodeURIComponent(existing_array));
								// Loop through the existing array
								$.each(existing_array, function (index, element) {
									existing_source = element[0];
									//alert('existing_source ' + existing_source);
									existing_destination = element[1];
									//alert('existing_destination ' + existing_destination);
									// Create the nested array
									merge_list_array[merge_list_counter] = new Array();
									// Add the items to the nested array
									merge_list_array[merge_list_counter][0] = existing_source;
									merge_list_array[merge_list_counter][1] = existing_destination;
									merge_list_counter++;
									});
								//alert('merge_list_counter: ' + merge_list_counter);
								
								// Check to see if the item already exists in the array
								for (var i = 0; i < merge_list_counter; i++) {
									//alert('merge_source: ' + decodeURIComponent(merge_source) + ' =?= merge_list_array[i][0]: ' + decodeURIComponent(merge_list_array[i][0]));
									if (merge_source == merge_list_array[i][0]) {
										//alert('merge_destination: ' + decodeURIComponent(merge_destination) + ' =?= merge_list_array[i][1]: ' + decodeURIComponent(merge_list_array[i][0]));
										if (merge_destination == merge_list_array[i][1]) {
											existing_test = 1;
											} // End if (merge_source == merge_list_array[i][0]) {
										} // End if (merge_destination == merge_list_array[i][1]) {
									} // End for (var i = 0; i < merge_list_counter; i++) {	
								} // End if (existing_array !== undefined) {
							//alert('existing_test: ' + existing_test);
							
							// Now add the new item to the array, only if it doesn't already exist
							if (existing_test == 0) {
								// Create the nested array
								merge_list_array[merge_list_counter] = new Array();
								// Add the items to the nested array
								merge_list_array[merge_list_counter][0] = merge_source;
								merge_list_array[merge_list_counter][1] = merge_destination;
								merge_list_counter++;
								} // End if (existing_test = 0) {
							} // End if (all_ok == 0) {
						//alert(merge_list_array);
						break; // End case 'add':
					
					
					case 'add-folder':
						var existing_array = $('input#id_performancedatatool_merge_list_array').val();
						//alert(existing_array);
						var existing_test = 0;
						
						// Get the foldername_array_source selected
						var foldername_array_source = jQuery.parseJSON(decodeURIComponent($('#id_all_host_folders_merge-source option:selected').val()));
						//alert('foldername_array_source = ' + foldername_array_source);
						
						// Check to make sure a source folder was selected
						if (foldername_array_source == null) {
							alert('You did not select a SOURCE folder');
							all_ok = 1;
							} // End if (foldername_array_source == null) {
						else {
							// Get the foldername_source
							var foldername_source = foldername_array_source.folder_name;
							//alert('foldername_source = ' + foldername_source);
							// Get the folderlocation_source
							var folderlocation_source = foldername_array_source.folder_location;
							//alert('folderlocation_source = ' + folderlocation_source);
							// Get the foldertype_source
							var foldertype_source = foldername_array_source.folder_type;
							//alert('foldertype_source = ' + foldertype_source);
							} // End else {
						
						// Get the foldername_array_destination selected
						var foldername_array_destination = jQuery.parseJSON(decodeURIComponent($('#id_all_host_folders_merge-destination option:selected').val()));
						//alert('foldername_array_destination = ' + foldername_array_destination);
						
						// Check to make sure a destination folder was selected
						if (foldername_array_destination == null) {
							alert('You did not select a DESTINATION folder');
							all_ok = 1;
							} // End if (foldername_array_destination == null) {
						else {
							// Get the foldername_destination
							var foldername_destination = foldername_array_destination.folder_name;
							//alert('foldername_destination = ' + foldername_destination);
							// Get the folderlocation_destination
							var folderlocation_destination = foldername_array_destination.folder_location;
							//alert('folderlocation_destination = ' + folderlocation_destination);
							// Get the foldertype_destination
							var foldertype_destination = foldername_array_destination.folder_type;
							//alert('foldertype_destination = ' + foldertype_destination);
							} // End else {
						
						// Check to make sure that the source and destination are not the same folder
						if ((foldername_array_source != null) && (foldername_array_destination != null)) {
							// Define the full path of the source folder
							switch (foldertype_source) {
								case 'type0':
									folderfullpath_source = '/usr/local/nagios/share/perfdata/' + foldername_source;
									break; // End case 'type0':
								
								case 'type1':
									folderfullpath_source = folderlocation_source + '/' + foldername_source;
									break; // End case 'type1':
								
								case 'type2':
									folderfullpath_source = folderlocation_source;
									break; // End case 'type2':
								} // End switch (foldertype_source) {
							
							// Define the full path of the destination folder
							switch (foldertype_destination) {
								case 'type0':
									folderfullpath_destination = '/usr/local/nagios/share/perfdata/' + foldername_destination;
									break; // End case 'type0':
								
								case 'type1':
									folderfullpath_destination = folderlocation_destination + '/' + foldername_destination;
									break; // End case 'type1':
								
								case 'type2':
									folderfullpath_destination = folderlocation_destination;
									break; // End case 'type2':
								} // End switch (foldertype_destination) {
							
							// Now do the check 
							if (folderfullpath_source == folderfullpath_destination) {
								alert('The SOURCE and DESTINATION folders CANNOT be the same');
								all_ok = 1;
								} // End if (folderfullpath_source == folderfullpath_destination) {
							
							} // End if ((foldername_array_source != null) && (foldername_array_destination != null)) {
						
						if (all_ok == 0) {
							var existing_array = $('input#id_performancedatatool_merge_list_array').val();
							//alert(existing_array);
							
							// Define the array we will load onto the page
							var merge_list_array = new Array();
							var merge_list_counter = 0;
							
							// If the PHP message list array already exists we need to add these to the JavaScript array
							if (existing_array !== undefined) {
								// Decode and JSON the existing array
								existing_array = jQuery.parseJSON(decodeURIComponent(existing_array));
								// Loop through the existing array
								$.each(existing_array, function (index, element) {
									existing_source = element[0];
									existing_destination = element[1];
									// Create the nested array
									merge_list_array[merge_list_counter] = new Array();
									// Add the items to the nested array
									merge_list_array[merge_list_counter][0] = existing_source;
									merge_list_array[merge_list_counter][1] = existing_destination;
									merge_list_counter++;
									});
								//alert('merge_list_counter: ' + merge_list_counter);
							} // End if (existing_array !== undefined) {
							
							// Get all the table rows in the table_source
							var table_source = $('#PerformanceDataTable-merge-source-' + foldername_source + ' tr');
							
							// Get all the table rows in the table_destination
							var table_destination = $('#PerformanceDataTable-merge-destination-' + foldername_destination + ' tr');
							
							// Loop through all all the table rows in the table_source
							table_source.each(function() {
								// Loop through all all the table cells in the row
								$(this).children('td').each (function() {
									// Now only look at table cells that have an id
									if ($(this).attr('id') !== undefined) {
										// Decode the cell array
										var td_array_source = jQuery.parseJSON(decodeURIComponent($(this).attr('id')));
										// Get the source filename
										var td_filename_source = td_array_source.filename;
										//alert(td_filename_source);
										// Loop through all all the table rows in the table_destination
										table_destination.each(function() {
											// Loop through all all the table cells in the row
											$(this).children('td').each (function() {
												// Now only look at table cells that have an id
												if ($(this).attr('id') !== undefined) {
													// Decode the cell array
													var td_array_destination = jQuery.parseJSON(decodeURIComponent($(this).attr('id')));
													// Get the destination filename
													var td_filename_destination = td_array_destination.filename;
													//alert(td_filename_destination);
													
													// Now check to see if the source and destination filenames match
													switch (match_type) {
														case 'case-sensitive':
															if (td_filename_source == td_filename_destination) {
																var folder_match = 'yes';
																} // End if (td_filename_source == td_filename_destination) {
															break; // End case 'case-sensitive':
														
														case 'case-insensitive':
															if (td_filename_source.toLowerCase() == td_filename_destination.toLowerCase()) {
																var folder_match = 'yes';
																} // End if (td_filename_source.toLowerCase() == td_filename_destination.toLowerCase()) {
															break; // End case 'case-sensitive':
														} // End switch (match_type) {
													
													if (folder_match == 'yes') {
														//alert('match ' + td_filename_source + ' and ' + td_filename_destination);
														
														// Check to see if the item already exists in the merge_list_array
														var existing_test = 0;
														for (var i = 0; i < merge_list_counter; i++) {
															if (folderfullpath_source + '/' + td_filename_source == merge_list_array[i][0]) {
																if (folderfullpath_destination + '/' + td_filename_destination == merge_list_array[i][1]) {
																	existing_test = 1;
																	} // End if (folderfullpath_destination + '/' + td_filename_destination == merge_list_array[i][1]) {
																} // End if (folderfullpath_source + '/' + td_filename_source == merge_list_array[i][0]) {
															} // End for (var i = 0; i < merge_list_counter; i++) {	
														//alert('existing_test: ' + existing_test);
											
														// Now add the new item to the array, only if it doesn't already exist
														if (existing_test == 0) {
															// Create the nested array
															merge_list_array[merge_list_counter] = new Array();
															// Add the items to the nested array
															merge_list_array[merge_list_counter][0] = folderfullpath_source + '/' + td_filename_source;
															merge_list_array[merge_list_counter][1] = folderfullpath_destination + '/' + td_filename_destination;
															merge_list_counter++;
															} // End if (existing_test = 0) {
													
														} // End if (folder_match == 'yes') {
													} // End if ($(this).attr('id') !== undefined) {
												}); // End $(this).children('td').each (function() {
											}); // End table_destination.each(function() {
										} // End if ($(this).attr('id') !== undefined) {
									}); // End $(this).children('td').each (function() {
								});	// End table_source.each(function() {
							//alert('merge_list_array ' + merge_list_array);
							} // End if (all_ok == 0) {
						
						break; // End case 'add-folder':
					
					
					case 'add-structure':
						var existing_array = $('input#id_performancedatatool_merge_list_array').val();
						//alert(existing_array);
						var existing_test = 0;
						
						// Get the foldername_array_source selected
						var foldername_array_source = jQuery.parseJSON(decodeURIComponent($('#id_all_custom_structure_folders_merge-source option:selected').val()));
						//alert('foldername_array_source = ' + foldername_array_source);
						
						// Check to make sure a source folder was selected
						if (foldername_array_source == null) {
							alert('You did not select a SOURCE folder');
							all_ok = 1;
							} // End if (foldername_array_source == null) {
						else {
							// Get the folderlocation_source
							var folderlocation_source = foldername_array_source.folder_location;
							//alert('folderlocation_source = ' + folderlocation_source);
							} // End else {
						
						// Get the folderlocation_destination selected
						var folderlocation_destination = jQuery.parseJSON(decodeURIComponent($('#id_perfdata_structure_folders_merge-destination option:selected').val()));
						//alert('foldername_destination = ' + foldername_destination);
						
						// Check to make sure a destination folder was selected
						if (folderlocation_destination == null) {
							alert('You did not select a DESTINATION folder');
							all_ok = 1;
							} // End if (folderlocation_destination == null) {
						
						if (all_ok == 0) {
							var existing_array = $('input#id_performancedatatool_merge_list_array').val();
							//alert(existing_array);
							
							// Define the array we will load onto the page
							var merge_list_array = new Array();
							var merge_list_counter = 0;
							
							// If the PHP message list array already exists we need to add these to the JavaScript array
							if (existing_array !== undefined) {
								// Decode and JSON the existing array
								existing_array = jQuery.parseJSON(decodeURIComponent(existing_array));
								// Loop through the existing array
								$.each(existing_array, function (index, element) {
									existing_source = element[0];
									existing_destination = element[1];
									// Create the nested array
									merge_list_array[merge_list_counter] = new Array();
									// Add the items to the nested array
									merge_list_array[merge_list_counter][0] = existing_source;
									merge_list_array[merge_list_counter][1] = existing_destination;
									merge_list_counter++;
									});
								//alert('merge_list_counter: ' + merge_list_counter);
							} // End if (existing_array !== undefined) {
							
							// Get all the perfdata folders in the source location
							var source_perfdata_folders;
							$.ajax({
								type: 'GET',
								url: '/nagiosxi/includes/components/performancedatatool/performance_data_tool_misc.php',
								data: {
									'request'				: 'structure-folders',
									'merge_folder_location'	: folderlocation_source,
									}, // End data: {
								async: false,
								}) // #End $.ajax({ 
								.done(function (response) {
									// Add the response to a variable
									source_perfdata_folders = jQuery.parseJSON(decodeURIComponent(response));
									}); // End .done(function (response) {
							//alert('source_perfdata_folders ' + source_perfdata_folders);
							
							// Get all the perfdata folders in the destination location
							var destination_perfdata_folders;
							$.ajax({
								type: 'GET',
								url: '/nagiosxi/includes/components/performancedatatool/performance_data_tool_misc.php',
								data: {
									'request'				: 'structure-folders',
									'merge_folder_location'	: folderlocation_destination,
									}, // End data: {
								async: false,
								}) // #End $.ajax({ 
								.done(function (response) {
									// Add the response to a variable
									destination_perfdata_folders = jQuery.parseJSON(decodeURIComponent(response));
									}); // End .done(function (response) {
							//alert('destination_perfdata_folders ' + destination_perfdata_folders);
							
							// Loop through all the source folders
							$.each(source_perfdata_folders, function (index_source, element_source) {
								// Define source_folder
								source_folder = element_source;
								//alert('source_folder ' + source_folder);
								
								// Loop through all the destination folders
								$.each(destination_perfdata_folders, function (index_destination, element_destination) {
									destination_folder = element_destination;
									//alert('destination_folder ' + destination_folder);
									
									// Do the source and destination match
									switch (match_type) {
										case 'case-sensitive':
											if (source_folder == destination_folder) {
												var folder_match = 'yes';
												} // End if (source_folder == destination_folder) {
											break; // End case 'case-sensitive':
										
										case 'case-insensitive':
											if (source_folder.toLowerCase() == destination_folder.toLowerCase()) {
												var folder_match = 'yes';
												} // End if (source_folder.toLowerCase() == destination_folder.toLowerCase()) {
											break; // End case 'case-sensitive':
										} // End switch (match_type) {
								
									// If there was a match, do an ajax request to match any files in these folders
									if (folder_match == 'yes') {
										//alert('source_folder ' + source_folder + ' and destination_folder ' + destination_folder);
										var source_folder_path = folderlocation_source + '/' + source_folder;
										var destination_folder_path = folderlocation_destination + '/' + destination_folder;
										var matched_perfdata_files;
										$.ajax({
											type: 'GET',
											url: '/nagiosxi/includes/components/performancedatatool/performance_data_tool_misc.php',
											data: {
												'request'				: 'structure-file-match',
												'match_type'			: match_type,
												'source_location'		: encodeURIComponent(source_folder_path),
												'destination_location'	: encodeURIComponent(destination_folder_path),
												}, // End data: {
											async: false,
											}) // #End $.ajax({ 
											.done(function (response) {
												// Add the response to a variable
												matched_perfdata_files = jQuery.parseJSON(decodeURIComponent(response));
												}); // End .done(function (response) {
										
										// Check to see if there were any matches
										if (matched_perfdata_files != '') {
											//alert('matched_perfdata_files ' + matched_perfdata_files);
											
											$.each(matched_perfdata_files, function (index, element) {
												source_file = element[0];
												destination_file = element[1];
												//alert('source_file ' + source_file + ' and destination_file ' + destination_file);
											
												// Check to see if the item already exists in the merge_list_array
												var existing_test = 0;
												for (var i = 0; i < merge_list_counter; i++) {
													if (source_file == merge_list_array[i][0]) {
														if (destination_file == merge_list_array[i][1]) {
															existing_test = 1;
															} // End if (destination_file == merge_list_array[i][1]) {
														} // End if (source_file == merge_list_array[i][0]) {
													} // End for (var i = 0; i < merge_list_counter; i++) {	
												//alert('existing_test: ' + existing_test);
									
												// Now add the new item to the array, only if it doesn't already exist
												if (existing_test == 0) {
													// Create the nested array
													merge_list_array[merge_list_counter] = new Array();
													// Add the items to the nested array
													merge_list_array[merge_list_counter][0] = source_file;
													merge_list_array[merge_list_counter][1] = destination_file;
													merge_list_counter++;
													} // End if (existing_test = 0) {
												}); // End $.each(matched_perfdata_files, function (index, element) {
											} // End if (matched_perfdata_files != '') {
										} // End if (folder_match == 'yes') {
									}); // End $.each(destination_perfdata_folders, function (index_destination, element_destination) {
								}); // End $.each(source_perfdata_folders, function (index_source, element_source) {
							//alert('merge_list_array ' + merge_list_array);
							} // End if (all_ok == 0) {
						break; // End case 'add-structure':
					
					
					case 'remove':
						// Define the Remove array
						var remove_array = new Array();
						// Get any checked files
						$('input:checkbox.performancedatatool-checkbox-merge-list').each(function () {
							if (this.checked) {
								// Create the nested array
								remove_array[selection_test] = new Array();
								var item_checked = jQuery.parseJSON(decodeURIComponent($(this).val()));
								//alert(item_checked[0]);
								//alert(item_checked[1]);
								// Add the items to the nested array
								remove_array[selection_test][0] = item_checked[0];
								remove_array[selection_test][1] = item_checked[1];
								selection_test++;
								} // End if (this.checked) {
							}); // End $('input:checkbox.performancedatatool-checkbox-merge-list').each(function () {
						//alert('remove_array = ' + remove_array);
						
						// Check to see if no items were selected to be removed
						if (selection_test == 0) {
							// Hide the throbber image
							$(div_throbber_id).hide();
							alert('You did not SELECT any items to be REMOVED from the Merge List');
							all_ok = 1;
							} // End if (selection_test == 0) {
						else {
							// Build the Merge List Array, removing selected entries
							var existing_array = $('input#id_performancedatatool_merge_list_array').val();
							//alert('existing_array: ' + existing_array);
							
							// Define the array we will load onto the page
							var merge_list_array = new Array();
							var merge_list_counter = 0;
							
							// If the PHP message list array already exists we need to find these selected entries 
							if (existing_array !== undefined) {
								// Decode and JSON the existing array
								existing_array = jQuery.parseJSON(decodeURIComponent(existing_array));
								// Loop through the existing array
								$.each(existing_array, function (index, element) {
									existing_source = element[0];
									//alert('existing_source ' + existing_source);
									existing_destination = element[1];
									//alert('existing_destination ' + existing_destination);
									var existing_test = 0;
							
									// Check to see if the item already exists in the remove array
									for (var i = 0; i < selection_test; i++) {
										//alert ('existing_source: ' + existing_source + ' remove_array source: ' + remove_array[i][0]);
										//alert ('existing_destination: ' + existing_destination + ' remove_array destination: ' + remove_array[i][1]);
										if (existing_source == remove_array[i][0]) {
											if (existing_destination == remove_array[i][1]) {
												existing_test = 1;
												} // End if (decodeURIComponent(merge_source) == remove_array[i][0]) {
											} // End if (decodeURIComponent(merge_destination) == remove_array[i][1]) {
										} // End for (var i = 0; i < selection_test; i++) {		
									
									// If the item didn't exist in the remove array it gets added to the merge list array
									if (existing_test == 0) {
										// Create the nested array
										merge_list_array[merge_list_counter] = new Array();
										// Add the items to the nested array
										merge_list_array[merge_list_counter][0] = existing_source;
										merge_list_array[merge_list_counter][1] = existing_destination;
										merge_list_counter++;
										} // End if (existing_test == 0) {
									}); // End $.each(existing_array, function (index, element) {
								} // End if (existing_array !== undefined) {		
							//alert('merge_list_counter: ' + merge_list_counter);
							} // End else {
						break; // End case 'remove':
						

					case 'clear':
						
						break; // End case 'clear':
						
					} // End switch (action_selected) {
				break; // End case 'merge_list': 'merge_list_specific': 'merge_list_folder': 'merge_list_structure':
			} // End switch (action) {
		

		// Perform the relevant action
		if (all_ok == 0) {
			switch (action) {
				case 'delete':
					switch (action_selected) {
						case 'delete_selected_items':
							var answer = confirm('Delete selected FILES?\n\nOK = Yes\n\nCancel = No');
							break; // End case 'delete_selected_items':
						
						case 'delete_folder':
							var answer = confirm('Delete FOLDER and CONTENTS?\n\nOK = Yes\n\nCancel = No');
							break; // End case 'delete_folder':
							
						} // End switch (action_selected) {	
							
					if (answer) {
						// Define the Content DIV
						var performancedatatool_content_div_id = '#performancedatatool-content-' + action_selected;
						
						// Open the window to display the throbber image
						var DeleteWindow = window.open('/nagiosxi/includes/components/performancedatatool/performance_data_tool_misc.php?request=throbber&id=' + action_selected,'_blank','width=1000,height=600,scrollbars=yes,resizable=yes');

						// Define the progress DIV ID
						var progress_div_id = '#performancedatatool-progress-' + action_selected;
												
						// Wait till the page has loaded
						DeleteWindow.onload = new function() {
							// I needed to set a timeout as the opened window was not always being updated!
							setTimeout(function() {
								switch (action_selected) {
									case 'delete_selected_items':
										// This will be used when displaying the progress on the screen
										delete_total_items = delete_array.length;
										delete_current_item = 1; 
										//alert('delete_total_items: ' + delete_total_items)
										
										// Loop through the delete array
										$.each(delete_array, function (index, element) {
											// Update the progress status using an ajax request
											$.ajax({
												type: 'GET',
												url: '/nagiosxi/includes/components/performancedatatool/performance_data_tool_misc.php',
												data: {
													'request'		: 'progress',
													'action'		: 'update',
													'total_items'	: delete_total_items,
													'current_item'	: delete_current_item,
													}, // End data: {
												async: false,
												}) // #End $.ajax({ 
												.done(function (response) {
													// Add the response to a child DIV
													$(progress_div_id, DeleteWindow.document.body).html(response);
													}); // End .done(function (response) {
											// Delete Folder Name
											delete_folder_name = element[0];
											//alert('delete_folder_name: ' + delete_folder_name);
											// Delete File Name
											delete_file_name = element[1];
											//alert('delete_file_name: ' + delete_file_name);
											// Delete Folder Location
											delete_folder_location = element[2];
											//alert('delete_folder_location: ' + delete_folder_location);
											// Perform the ajax request
											$.ajax({
												type: 'GET',
												url: '/nagiosxi/includes/components/performancedatatool/performance_data_tool_actions.php',
												data: {
													'action'					: 'delete',
													'action_selected'			: action_selected,
													'delete_folder_name'		: encodeURIComponent(delete_folder_name),
													'delete_folder_location'	: encodeURIComponent(delete_folder_location),
													'delete_file_name'			: encodeURIComponent(delete_file_name),
													}, // End data: {
												async: false,
												}) // #End $.ajax({ 
												.done(function (response) {
													// Append the response to a child DIV
													$(performancedatatool_content_div_id, DeleteWindow.document.body).append(response);
													}); // End .done(function (response) {
											delete_current_item++;
											}); // End $.each(delete_array, function (index, element) {
										
										// Refresh the table on the parent window
										performancedatatool_draw_table('delete');
										// Reset the action select to nothing selected
										$('#id_action_delete option:selected').prop('selected', false);
										
										// Adjust delete_current_item
										delete_current_item = delete_current_item - 1;
										// Update the progress status using an ajax request
										$.ajax({
											type: 'GET',
											url: '/nagiosxi/includes/components/performancedatatool/performance_data_tool_misc.php',
											data: {
												'request'		: 'progress',
												'action'		: 'finished',
												'total_items'	: delete_total_items,
												'current_item'	: delete_current_item,
												}, // End data: {
											async: false,
											}) // #End $.ajax({ 
											.done(function (response) {
												// Add the response to a child DIV
												$(progress_div_id, DeleteWindow.document.body).html(response);
												}); // End .done(function (response) {
										break; // End case 'delete_selected_items':
									

									case 'delete_folder':
										// Perform the ajax request
										$.ajax({
											type: 'GET',
											url: '/nagiosxi/includes/components/performancedatatool/performance_data_tool_actions.php',
											data: {
												'action'			: 'delete',
												'action_selected'	: action_selected,
												'foldername' 		: encodeURIComponent(foldername),
												'folderlocation'	: encodeURIComponent(folderlocation),
												}, // End data: {
											async: false,
											}) // #End $.ajax({ 
											.done(function (response) {
												// Add the response to a child DIV
												$(performancedatatool_content_div_id, DeleteWindow.document.body).append(response);
												}); // End .done(function (response) {

										// Update Progress
										var delete_folder_count_output = DeleteWindow.document.getElementById('id_performancedatatool_delete_folder_count_output').value;
										//alert('delete_folder_count_output ' + delete_folder_count_output);
										var delete_folder_item_word = DeleteWindow.document.getElementById('id_performancedatatool_delete_folder_item_word').value;
										//alert('delete_folder_item_word ' + delete_folder_item_word);
									
										if (delete_folder_item_word != 'none') {
											// Update the progress status using an ajax request
											$.ajax({
												type: 'GET',
												url: '/nagiosxi/includes/components/performancedatatool/performance_data_tool_misc.php',
												data: {
													'request'		: 'progress',
													'action'		: 'finished',
													'total_items'	: delete_folder_count_output,
													'current_item'	: delete_folder_count_output,
													}, // End data: {
												async: false,
												}) // #End $.ajax({ 
												.done(function (response) {
													// Add the response to a child DIV
													$(progress_div_id, DeleteWindow.document.body).html(response);
													}); // End .done(function (response) {
											} // End if (delete_folder_item_word != 'none') {
										
										// Hide the date filter DIV on the parent window
										$('#performancedatatool-date-filter-delete').hide();
										// Hide the refresh button DIV on the parent window
										$('#performancedatatool-refresh-table-delete').hide();
										// Hide the table DIV on the parent window
										$('#performancedatatool-delete-table').hide();
										// Hide the action DIV on the parent window
										$('#performancedatatool-action-delete').hide();
										// Reset the action select to nothing selected
										$('#id_action_delete option:selected').prop('selected', false);
										// Refresh the folder list
										performancedatatool_misc('host-select,delete');
										break; // End case 'delete_folder':
										
									} // End switch (action_selected) {

								// For some reason I need to hide/show this way otherwise Internet Explorer has issues
								// Hide the throbber DIV
								DeleteWindow.document.getElementById('performancedatatool-throbber-' + action_selected).style.display = 'none';
								// Show the finished DIV
								DeleteWindow.document.getElementById('performancedatatool-finished-' + action_selected).style.display = 'block';
								},3000); // End setTimeout(function() {
							} // End DeleteWindow.onload = new function() {
						} // End if (answer) {
					else {
						} // End else {
		
					break; // End case 'delete':
				

				case 'merge_list':
				case 'merge_list_specific':
				case 'merge_list_folder':
				case 'merge_list_structure':
					var div_merge_submit_button_id = '#performancedatatool-merge-submit-button';
					
					switch (action_selected) {
						case 'add':
						case 'remove':
						case 'add-folder':
						case 'add-structure':
							// Turning the merge_list_array into a JSON
							merge_list_array = JSON.stringify(merge_list_array);
							// Show the Merge List
							// The following load string is required otherwise PHP complains 'URI too long (longer than 8190)'
							performancedatatool_ajaxSetup();
							$(div_merge_list_id).load(
								'/nagiosxi/includes/components/performancedatatool/performance_data_tool_draw_table.php',
								{
									'select_supplied_name'	: 'merge_list',
									'merge_list_array'		:encodeURIComponent(merge_list_array),
									}
								); // End $('#performancedatatool-merge-list').load(
							// Show the Merge List Submit button if the Merge List is NOT empty
							if (merge_list_counter > 0) {
								// Load the DIV
								performancedatatool_ajaxSetup();
								$(div_merge_submit_button_id).load(
									'/nagiosxi/includes/components/performancedatatool/performance_data_tool_misc.php',
									{
										'request'	: 'merge_submit_button',
										}
									); // End $(div_merge_submit_button_id).load(

								// Show the Merge List
								$(div_merge_list_id).show();

								// Show the submit DIV
								$(div_merge_submit_button_id).show();
								} // End if (merge_list_counter > 0) {
							else {
								// Hide the submit DIV
								$(div_merge_submit_button_id).hide();
								} // End else {
							break; // End case 'add': 'remove': 'add-folder': 'add-structure':
						
						case 'clear':
							// Show the Merge List
							$(div_merge_list_id).load(
								'/nagiosxi/includes/components/performancedatatool/performance_data_tool_draw_table.php',
								{
									'select_supplied_name'	: 'merge_list',
									'merge_list_array'		: '',
									}
								); // End $('#performancedatatool-merge-list').load(
							// Hide the submit DIV
							$(div_merge_submit_button_id).hide();
							break; // End case 'clear':
						
						} // End switch (action_selected) {
					// Hide the throbber image
					$(div_throbber_id).hide();
					break; // End case 'merge_list': 'merge_list_specific': 'merge_list_folder': 'merge_list_structure':
				
				} /* End switch (action) { */
			} // End if (all_ok == 0) {
		} // End else {
	} // End function performancedatatool_perform_action(action) {


function performancedatatool_perform_merge() {
	var merge_type_selected = $('#id_merge option:selected').val();
	switch (merge_type_selected) {
		case 'specific':
		case 'folder':
		case 'structure':
			// Define the Content DIV
			var performancedatatool_content_div_id = '#performancedatatool-content-' + merge_type_selected;
			
			// Get the merge list array
			var merge_list_array = jQuery.parseJSON(decodeURIComponent($('input#id_performancedatatool_merge_list_array').val()));
			
			// Open the window to display the throbber image
			var MergeWindow = window.open('/nagiosxi/includes/components/performancedatatool/performance_data_tool_misc.php?request=throbber&id=' + merge_type_selected,'_blank','width=1000,height=600,scrollbars=yes,resizable=yes');
			
			// This will be used when displaying the progress on the screen
			merge_list_total_items = merge_list_array.length;
			merge_list_current_item = 1; 
			//alert('merge_list_total_items: ' + merge_list_total_items)
			
			// Wait till the page has loaded
			MergeWindow.onload = new function() {
				// I needed to set a timeout as the opened window was not always being updated!
				setTimeout(function() {
					// Define the progress DIV ID
					var progress_div_id = '#performancedatatool-progress-' + merge_type_selected;
					
					// Loop through the existing array
					$.each(merge_list_array, function (index, element) {
						// Update the progress status using an ajax request
						$.ajax({
							type: 'GET',
							url: '/nagiosxi/includes/components/performancedatatool/performance_data_tool_misc.php',
							data: {
								'request'		: 'progress',
								'action'		: 'update',
								'total_items'	: merge_list_total_items,
								'current_item'	: merge_list_current_item,
								}, // End data: {
							async: false,
							}) // #End $.ajax({ 
							.done(function (response) {
								// Add the response to a child DIV
								$(progress_div_id, MergeWindow.document.body).html(response);
								}); // End .done(function (response) {
						// Merge Source
						merge_source = element[0];
						//alert('merge_source ' + merge_source);
						// Merge Destination
						merge_destination = element[1];
						//alert('merge_destination ' + merge_destination);
						// Perform the ajax request
						$.ajax({
							type: 'GET',
							url: '/nagiosxi/includes/components/performancedatatool/performance_data_tool_actions.php',
							data: {
								'action'				: 'merge',
								'merge_type_selected'	: merge_type_selected,
								'merge_source'			: encodeURIComponent(merge_source),
								'merge_destination'		: encodeURIComponent(merge_destination),
								}, // End data: {
							async: false,
							}) // #End $.ajax({ 
							.done(function (response) {
								// Add the response to a child DIV
								$(performancedatatool_content_div_id, MergeWindow.document.body).append(response);
								}); // End .done(function (response) {
						// Increment the current item
						merge_list_current_item++;
						}); // End $.each(merge_list_array, function (index, element) {
					
					// Adjust merge_list_current_item
					merge_list_current_item = merge_list_current_item - 1;
					// Update the progress status using an ajax request
					$.ajax({
						type: 'GET',
						url: '/nagiosxi/includes/components/performancedatatool/performance_data_tool_misc.php',
						data: {
							'request'			: 'progress',
							'action'			: 'finished',
							'total_items'		: merge_list_total_items,
							'current_item' 		: merge_list_current_item,
							}, // End data: {
						async: false,
						}) // #End $.ajax({ 
						.done(function (response) {
							// Add the response to a child DIV
							$(progress_div_id, MergeWindow.document.body).html(response);
							}); // End .done(function (response) {

					// Hide the throbber DIV
					MergeWindow.document.getElementById('performancedatatool-throbber-' + merge_type_selected).style.display = 'none';
					// Show the finished DIV
					MergeWindow.document.getElementById('performancedatatool-finished-' + merge_type_selected).style.display = 'block';
					},3000); // End setTimeout(function() {
				} // End MergeWindow.onload = new function() {
			break; // End case 'specific': 'folder': 'structure':
		
		} // End switch (type) {
	} // End function performancedatatool_perform_merge(type) {

	
	
function performancedatatool_ToolTipShowContent() {
	$('.item_click').click(function(event){
		var item_clicked = jQuery.parseJSON(decodeURIComponent(event.target.id));
		var foldername = item_clicked.foldername;
		var folderlocation = item_clicked.folderlocation;
		var foldertype = item_clicked.foldertype;
		var filename = item_clicked.filename;
		//alert('foldername: ' + foldername);
		//alert('folderlocation:' + folderlocation);
		//alert('foldertype:' + foldertype);
		//alert('filename:' + filename);
		window.open('/nagiosxi/includes/components/performancedatatool/performance_data_tool_display_contents.php?foldername=' + encodeURIComponent(foldername) + '&folderlocation=' + encodeURIComponent(folderlocation) + '&foldertype=' + foldertype + '&filename=' + encodeURIComponent(filename),'_blank','width=1000,height=600,scrollbars=yes,resizable=yes');
		}); // End $('.item_click').click(function(event){
	} // End function performancedatatool_ToolTipShowContent() {
