<?php  
// Performance Data Tool COMPONENT
//
// Copyright 2016-05-05 Troy Lea aka Box293
// 

require_once(dirname(__FILE__).'/../../common.inc.php');

// initialization stuff
pre_init();
// start session
init_session();
// grab GET or POST variables 
grab_request_vars();
// check prereqs
check_prereqs();
// check authentication
check_authentication(false);

/* Create the HTML Header */
?>
<!DOCTYPE html>
	<html>
	<head>
	<title></title>
	<meta http-equiv='Content-Type' content='text/html; charset=UTF-8' />
	<?php
	do_page_head_links();
	?>
	<link href="../performancedatatool/performance_data_tool.css" rel="stylesheet" type="text/css" />
	<script type="text/javascript" src="../performancedatatool/performance_data_tool.js"></script>
	<script type="text/javascript" src="../../js/jquery/jquery.tablesorter.js"></script>
	<script type="text/javascript" src="../../js/jquery/jquery-ui-1.9.0.custom.min.js"></script>
	</head>
<?php

/* This adds padding for XI 5.x onwards */
if (get_product_release() > 416) {
	?>
		<body style="padding: 0px 5px 5px 5px;">
	<?php
	} /* End if (get_product_release() > 416) { */
else {
	?>
		<body>
	<?php
	} /* End else { */
	
/* Build the HTML content */
$html = performancedatatool_build_html();
print $html; 

/* FUNCTIONS */

function performancedatatool_build_html() {
	$html = '
	<h3>Performance Data Tool</h3>
	
	<div id="menubar">
		<input type="button" class="performancedatatool-menuheading2" id="id-performancedatatool-overview" onclick="performancedatatool_ToggleMenu(\'performancedatatool-overview\')" value="Overview">
		<input type="button" class="performancedatatool-menuheading1" id="id-performancedatatool-browse" onclick="performancedatatool_ToggleMenu(\'performancedatatool-browse\')" value="Browse">
		';
	/* Only show the following menu options if the user is an admin */
	if(is_admin() == true) {
		$html .= '
		<input type="button" class="performancedatatool-menuheading1" id="id-performancedatatool-merge" onclick="performancedatatool_ToggleMenu(\'performancedatatool-merge\')" value="Merge">
		<input type="button" class="performancedatatool-menuheading1" id="id-performancedatatool-delete" onclick="performancedatatool_ToggleMenu(\'performancedatatool-delete\')" value="Delete">
		<input type="button" class="performancedatatool-menuheading1" id="id-performancedatatool-configure" onclick="performancedatatool_ToggleMenu(\'performancedatatool-configure\')" value="Configure">
		';
		} // End if(is_admin() == true) {
	$html .= '
		<input type="button" class="performancedatatool-menuheading1" id="id-performancedatatool-help" onclick="performancedatatool_ToggleMenu(\'performancedatatool-help\')" value="Help">
		<input type="button" class="performancedatatool-menuheading1" id="id-performancedatatool-license" onclick="performancedatatool_ToggleMenu(\'performancedatatool-license\')" value="License">
	</div>
	
	
	<div id="performancedatatool-overview" class="performancedatatool-togglediv">
		<div class="performancedatatool-spacer5"> </div>
		<div class="performancedatatool-font-weight-bold">Overview</div>
		<div class="performancedatatool-spacer20"> </div>
		Welcome to the Performance Data Tool.
		<div class="performancedatatool-spacer10"> </div>
		The purpose of the Performance Data Tool is to give you the ability to view and manipulate the .rrd and .xml performance data files on your Nagios XI host.
		<div class="performancedatatool-spacer5"> </div>
		This can be helpful for:
		<div class="performancedatatool-spacer5"> </div>
		<ul>
			<li>Viewing graphs for services that have been disabled</li>
			<ul>
				<li>Because they are disabled you can no longer access the graphs to refer to the historical performance data.</li>
			</ul>
			<li>Viewing RRD files in a table format</li>
			<ul>
				<li>Can be easier to browse data compared to looking at graphs</li>
			</ul>
			<li>Merging RRD files</li>
			<ul>
				<li>If you rename a host/service the performance data can be merged into the new RRD files</li>
				<li>After a Nagios host rebuild, the old performance data can restored and then merged into the new RRD files on the rebuilt Nagios host</li>
			</ul>
			<li>Deleting performance data</li>
			<ul>
				<li>Cleaning up old RRD and XML files that were left behind when a host/service was decommissioned</li>
			</ul>
		</ul>
		<div class="performancedatatool-spacer10"> </div>
		Refer to the Help tab for more information on what this component can do.
		
		<div class="performancedatatool-spacer20"> </div>
	</div> <!-- End performancedatatool-overview -->
	
	
	
	<div id="performancedatatool-browse" class="performancedatatool-togglediv" style="display:none">
		';
	$browse_date_filters_select = draw_select_of_date_filters('browse');
	
	$html .= '
		<div class="performancedatatool-spacer5"> </div>
		<div class="performancedatatool-font-weight-bold">Browse Performance Data</div>
		
		<div class="performancedatatool-spacer20"> </div>
	
		Please select a folder from the drop down list below to display the files in that folder.
		
		<div class="performancedatatool-spacer10"> </div>
		
		<input type="button" onclick="performancedatatool_misc(\'host-select,browse\')" value="Refresh Folders" style="float: left">
		
		<div id="performancedatatool-host-select-browse">
			<!-- This will be populated by the next line of JavaScript -->
		</div>
		
		<script>performancedatatool_misc(\'host-select,browse\')</script>
	
		<div class="performancedatatool-spacer10"> </div>
		
		<div id="performancedatatool-date-filter-browse" style="display:none">
			Date Filter: '.$browse_date_filters_select.'
		</div>
		
		<div class="performancedatatool-spacer10"> </div>

		<div id="performancedatatool-refresh-table-browse" style="display:none">
			<input type="button" onclick="performancedatatool_draw_table(\'browse\')" value="Refresh Table">
		</div>
		
		<div id="performancedatatool-browse-table-throbber" style="display:none">
				<br />
				'.get_throbber_html().'
		</div>
			
		<div id="performancedatatool-browse-table" style="display:none">
			<!-- This will be populated when the select is clicked -->
		</div>
		
		<div class="performancedatatool-spacer10"> </div>
		
	</div> <!-- End performancedatatool-browse -->

	
	
	';
	/* Only show the following if the user is an admin */
	if(is_admin() == true) {
		$html .= '
	
	<div id="performancedatatool-merge" class="performancedatatool-togglediv" style="display:none">
		';
	$merge_type_select = draw_select_of_merge_types();
	$merge_date_filters_source_select = draw_select_of_date_filters('merge-source');
	$merge_date_filters_destination_select = draw_select_of_date_filters('merge-destination');
	
	$html .= '
		<div class="performancedatatool-spacer5"> </div>
		<div class="performancedatatool-font-weight-bold">Merge Performance Data</div>
		
		<div class="performancedatatool-spacer20"> </div>
	
		Please select the type of merge that you wish to perform:
		
		<div class="performancedatatool-spacer10"> </div>
		
		'.$merge_type_select.'
				
		<div id="performancedatatool-merge-source" style="display:none">
			
			<h2>Source</h2>
	
			Please select a folder from the drop down list below to display the files in that folder.
			
			<div class="performancedatatool-spacer10"> </div>
			
			<input type="button" onclick="performancedatatool_misc(\'host-select,merge-source\')" value="Refresh Folders" style="float: left">
		
			<div id="performancedatatool-host-select-merge-source">
				<!-- This will be populated by the next line of JavaScript -->
			</div>
			
			<script>performancedatatool_misc(\'host-select,merge-source\')</script>
			
			<div class="performancedatatool-spacer10"> </div>
			
			<div id="performancedatatool-date-filter-merge-source" style="display:none">
				Date Filter: '.$merge_date_filters_source_select.'
			</div>
			
			<div class="performancedatatool-spacer10"> </div>

			<div id="performancedatatool-refresh-table-merge-source" style="display:none">
				<input type="button" onclick="performancedatatool_draw_table(\'merge-source\')" value="Refresh Table"> <input type="button" id="id_performancedatatool_button_hide_show_table_merge-source" onclick="performancedatatool_hide_show_table(\'merge-source\')" value="Hide Table">
			</div>
			
			<div id="performancedatatool-merge-source-table">
				<!-- This will be populated when the select is clicked -->
			</div>
			
			<div id="performancedatatool-merge-source-table-throbber" style="display:none">
				<br />
				'.get_throbber_html().'
			</div>
			
			<hr>
			
		</div>
		
		<div id="performancedatatool-merge-destination" style="display:none">
			
			<h2>Destination</h2>
	
			Please select a folder from the drop down list below to display the files in that folder.
			
			<div class="performancedatatool-spacer10"> </div>
			
			<input type="button" onclick="performancedatatool_misc(\'host-select,merge-destination\')" value="Refresh Folders" style="float: left">
		
			<div id="performancedatatool-host-select-merge-destination">
				<!-- This will be populated by the next line of JavaScript -->
			</div>
			
			<script>performancedatatool_misc(\'host-select,merge-destination\')</script>
			
			<div class="performancedatatool-spacer10"> </div>
			
			<div id="performancedatatool-date-filter-merge-destination" style="display:none">
				Date Filter: '.$merge_date_filters_destination_select.'
			</div>
			
			<div class="performancedatatool-spacer10"> </div>

			<div id="performancedatatool-refresh-table-merge-destination" style="display:none">
				<input type="button" onclick="performancedatatool_draw_table(\'merge-destination\')" value="Refresh Table"> <input type="button" id="id_performancedatatool_button_hide_show_table_merge-destination" onclick="performancedatatool_hide_show_table(\'merge-destination\')" value="Hide Table">
			</div>
			
			<div id="performancedatatool-merge-destination-table">
				<!-- This will be populated when the select is clicked -->
			</div>
			
			<div id="performancedatatool-merge-destination-table-throbber" style="display:none">
				<br />
				'.get_throbber_html().'
			</div>
			
			<hr>
			
		</div>
		
		
		<div id="performancedatatool-merge-structure-source" style="display:none">
			
			<h2>Source</h2>
	
			Please select a custom folder from the drop down list below.
			
			<div class="performancedatatool-spacer10"> </div>
			
			<input type="button" onclick="performancedatatool_misc(\'structure-select,merge-source\')" value="Refresh Folders" style="float: left">
		
			<div id="performancedatatool-structure-select-merge-source">
				<!-- This will be populated when the merge type is selected -->
			</div>
			
			<div class="performancedatatool-spacer10"> </div>
			
			<hr>
			
		</div>
		
		
		<div id="performancedatatool-merge-structure-destination" style="display:none">
			
			<h2>Destination</h2>
	
			The destination is always /usr/local/nagios/share/perfdata.
			
			<div class="performancedatatool-spacer10"> </div>
			
			<div id="performancedatatool-structure-select-merge-destination">
				<!-- This will be populated by the next line of JavaScript -->
			</div>
			
			<script>performancedatatool_misc(\'structure-select,merge-destination\')</script>
			
			<div class="performancedatatool-spacer10"> </div>
			
			<hr>
			
		</div>
		
		<div id="performancedatatool-merge-list-action" style="display:none">
			<!-- This will be populated when the Merge Type is selected -->
		</div>
		
		<div class="performancedatatool-spacer10"> </div>

		<!--
		<div id="performancedatatool-merge-list-match-type" style="display:none">
			<select name="merge_match_type" id="id_merge_match_type" title="Select a match type">
				<option value="case-sensitive" selected>CaSe sEnSiTiVe mAtCh</option>
				<option value="case-insensitive">case insensitive match</option>
			</select>
		</div>
		-->
		
		<div id="performancedatatool-merge-list-match-type" style="display:none" >
			CaSe sEnSiTiVe mAtCh <input type="radio" name="merge_match_type" value="case-sensitive" checked> <input type="radio" name="merge_match_type" value="case-insensitive"> case insensitive match
		</div>
		
		<div id="performancedatatool-merge-list-table-throbber" style="display:none">
			<br />
			'.get_throbber_html().'
		</div>
		
		<div id="performancedatatool-merge-submit-button" style="display:none">
			<!-- This will be populated when the add button is clicked -->
		</div>
	
		<div id="performancedatatool-merge-list" style="display:none">
			<h3><i>There are currently no items in the merge list!</i></h3>
		</div>

		<div id="performancedatatool-merge-structure-no-config" style="display:none">
			<h3>You do not have any custom folders defined, please see the Configure tab for more information</h3>
		</div>
		
	<div class="performancedatatool-spacer10"> </div>
	
	</div> <!-- End performancedatatool-merge -->
		';
		} // End if(is_admin() == true) {
	
	
	/* Only show the following if the user is an admin */
	if(is_admin() == true) {
		$html .= '
		
	<div id="performancedatatool-delete" class="performancedatatool-togglediv" style="display:none">
		';
	$delete_date_filters_select = draw_select_of_date_filters('delete');
	
	$html .= '
		<div class="performancedatatool-spacer5"> </div>
		<div class="performancedatatool-font-weight-bold">Delete Performance Data</div>
		
		<div class="performancedatatool-spacer20"> </div>
	
		Please select a folder from the drop down list below to display the files in that folder.
		
		<div class="performancedatatool-spacer10"> </div>
		
		<input type="button" onclick="performancedatatool_misc(\'host-select,delete\')" value="Refresh Folders" style="float: left">
		
		<div id="performancedatatool-host-select-delete">
			<!-- This will be populated by the next line of JavaScript -->
		</div>
		
		<script>performancedatatool_misc(\'host-select,delete\')</script>

		<div class="performancedatatool-spacer10"> </div>
		
		<div id="performancedatatool-date-filter-delete" style="display:none">
			Date Filter: '.$delete_date_filters_select.'
		</div>
		
		<div class="performancedatatool-spacer10"> </div>
		
		<div id="performancedatatool-refresh-table-delete" style="display:none">
			<input type="button" onclick="performancedatatool_draw_table(\'delete\')" value="Refresh Table"> <input type="button" id="id_performancedatatool_button_hide_show_table_delete" onclick="performancedatatool_hide_show_table(\'delete\')" value="Hide Table">
		</div>
		
		<div id="performancedatatool-delete-table">
			<!-- This will be populated when the select is clicked -->
		</div>
		
		<div id="performancedatatool-delete-table-throbber" style="display:none">
				<br />
				'.get_throbber_html().'
		</div>
		
		<div class="performancedatatool-spacer5"> </div>
		
		<div id="performancedatatool-action-delete" style="display:none">
			<!-- This will be populated by the next line of JavaScript -->
		</div>
		
		<script>performancedatatool_misc(\'delete,delete\')</script>
		
		<div class="performancedatatool-spacer10"> </div>
		
		<script type="text/javascript">
			$(document).ready(function() {
				$( document ).tooltip();
				}); 
		</script>
	</div> <!-- End performancedatatool-delete -->
		';
		} // End if(is_admin() == true) {
	
	
	/* Only show the following if the user is an admin */
	if(is_admin() == true) {
		$html .= '
		
	<div id="performancedatatool-configure" class="performancedatatool-togglediv" style="display:none">
		<div class="performancedatatool-spacer5"> </div>
		<div class="performancedatatool-font-weight-bold">Configure Settings</div>
			<div class="performancedatatool-spacer20"> </div>
		To configure the custom folders for the Performance Data Tool follow these steps:
		<ul>
			<li>Click the <b>Admin</b> tab at the top</li>
			<li>Under <b>System Extensions</b> click the <b>Manage Components</b> menu item</li>
			<li>Find the <b>Performance Data Tool</b> and click the <b>Configure</b> icon</li>
		</ul>
		
		<img src="../performancedatatool/images/config_example.png">
		
	</div> <!-- End performancedatatool-configure -->
		';
		} // End if(is_admin() == true) {
	$html .= '	
	
	
	<div id="performancedatatool-help" class="performancedatatool-togglediv" style="display:none">
		<div class="performancedatatool-spacer5"> </div>
		<label id="expand_collapse" onclick="performancedatatool_toggleAll(\'Tab-About:Tab-Common:Tab-Browse:Tab-Merge:Tab-Delete:Tab-Configure:Tab-Help:DiscountOffer:Troubleshooting:Support:Work-In-Progress:Project-Hours:My-Projects:Tab-License\')">Expand All</label>
		<div class="performancedatatool-spacer10"> </div>
		
		<div>
			<input type="button" class="performancedatatool-button01" onclick="performancedatatool_toggleMe(\'Tab-About\')" value="About Performance Data Files">
		</div>
		<div id="Tab-About" class="performancedatatool-hidden">
			<div class="performancedatatool-spacer5"> </div>
			What are Performance Data Files?
			<div class="performancedatatool-spacer5"> </div>
			Performance data files are used for recording the results from Nagios checks, which in turn become useful for observing the daily trends of your environment. Being able to look at hourly/daily/weekly/monthly/yearly historical data can be invaluabe when trying to resolve performance issues. It helps get to the bottom of those customer complaints like "the server is slow".
			<div class="performancedatatool-spacer5"> </div>
			There are two files created by Nagios for every check that generates performance data.
			<div class="performancedatatool-spacer5"> </div>
			<i>check</i>.rrd
			<div class="performancedatatool-spacer5"> </div>
			The RRD file is a Round Robin Database. That means that after some time the oldest data will be dropped at the "end" and it will be replaced by new values "at the beginning". This is the file that contains all the historical data.
			<div class="performancedatatool-spacer5"> </div>
			<i>check</i>.xml
			<div class="performancedatatool-spacer5"> </div>
			The XML file contains detailed information about the check that generated the performance data. Things like warning and critical thresholds, names of the checks, all of this data does not need to be stored in the RRD file.
			<div class="performancedatatool-spacer5"> </div>
			How are these files used?
			<div class="performancedatatool-spacer5"> </div>
			When you are viewing performance graphs in Nagios, they are generated by an application called PNP4Nagios. PNP4Nagios uses the XML and RRD files to generate these graphs. PNP4Nagios allows you to create your own customised graphs based on the information in the XML file and then displays the historical data in the RRD file.
			<div class="performancedatatool-spacer15"> </div>
		</div> <!-- End Tab-About -->
		
		<div class="performancedatatool-spacer5"> </div>
		
		<div>
			<input type="button" class="performancedatatool-button01" onclick="performancedatatool_toggleMe(\'Tab-Common\')" value="Common Functionality">
		</div>
		<div id="Tab-Common" class="performancedatatool-hidden">
			<div class="performancedatatool-spacer5"> </div>
			In the Browse, Merge and Delete tabs you will be presented with a list of RRD and XML files in their relative folders.
			<div class="performancedatatool-spacer5"> </div>
			You can click on any of the files in the list and the contents of that file will be displayed in a popup window.
			<div class="performancedatatool-spacer5"> </div>
			Currently the functionality of viewing the data as a graph is not yet implemented, this feature is coming soon!
			<div class="performancedatatool-spacer5"> </div>
			In relation to the RRD Raw Data, this is obtained with the RRDTOOL using the FETCH command.
			<div class="performancedatatool-spacer15"> </div>
		</div> <!-- End Tab-Common -->
		
		<div class="performancedatatool-spacer5"> </div>
		
		<div>
			<input type="button" class="performancedatatool-button01" onclick="performancedatatool_toggleMe(\'Tab-Browse\')" value="Browse">
		</div>
		<div id="Tab-Browse" class="performancedatatool-hidden">
			<div class="performancedatatool-spacer5"> </div>
			This page lets you browse through all the performance data files on your Nagios XI host.
			<div class="performancedatatool-spacer5"> </div>
			Simply select a host folder from the drop down list and you will be presented with a list of files.
			<div class="performancedatatool-spacer5"> </div>
			You can click on any of the files in the list and the contents of that file will be displayed in a popup window.
			<div class="performancedatatool-spacer10"> </div>
			<div class="performancedatatool-font-weight-bold">Admins vs Users</div>
			<div class="performancedatatool-spacer20"> </div>
			Only Admins can click XML files to display the contents. Standard users will be able to see that an XML exists but it will not be clickable. 
			<div class="performancedatatool-spacer15"> </div>
		</div> <!-- End Tab-Browse -->
		
		<div class="performancedatatool-spacer5"> </div>
		
		<div>
			<input type="button" class="performancedatatool-button01" onclick="performancedatatool_toggleMe(\'Tab-Merge\')" value="Merge">
		</div>
		<div id="Tab-Merge" class="performancedatatool-hidden">
			<div class="performancedatatool-spacer5"> </div>
			The Merge tab allows you to take data from one RRD file and insert it into another RRD file. Here\'s an example when this may be useful:
			<ul>
				<li>Lets say you replaced a network switch in your environment. All the same devices are connected to the new one, you just had to replace the switch due to warranty purposes. Since the switch is a newer model, you are monitoring it via a different IP Address and it has a different name</li>
				<li>The network ports on this new switch are now being monitored however you no longer have the historical data of all the devices connected to this switch (they were the same devices connected to the old switch)</li>
				<li>The historical data is still sitting there on your Nagios XI host, so this tool allows you to merge the data sitting in the old RRD files into the new RRD files</li>
			</ul>
			
			<div class="performancedatatool-spacer5"> </div>
			
			<div class="performancedatatool-font-weight-bold">The Merge List</div>
			<div class="performancedatatool-spacer20"> </div>
			To perform a merge, you create a list of files that you want to merge (called the Merge List).
			<div class="performancedatatool-spacer5"> </div>
			The Merge List allows you to perform multiple merges in one operation.
			
			<div class="performancedatatool-spacer10"> </div>
			<div class="performancedatatool-font-weight-bold">Merge Types</div>
			<div class="performancedatatool-spacer20"> </div>
			<ul>
				<li>Merge specific .rrd\'s</li>
				<ul>
					<li>Allows you to select individual items to add to the Merge List</li>
				</ul>
				<li>Merge all .rrd\'s in one folder into all .rrd\'s in another folder</li>
				<ul>
					<li>You can match all the files in one folder to the files in another folder</li>
					<li>Helpful if you renamed a host and now it has generated new performance data files, this allows you to add the old performance data to the new files</li>
					<li>You can select between a "CaSe sEnSiTiVe mAtCh" or a "case insensitive match"</li>
				</ul>
				<li>Merge entire folder structure of .rrd\'s into perfdata folder</li>
				<ul>
					<li>Helpful if you rebuild your Nagios XI server after it crashed</li>
					<ul>
						<li>Because the new server has generated new performance data files, you want the old performance data inserted into the new RRD files on the rebuilt Nagios XI host</li>
						<li>Requires you to restore the perfdata files (and folder structure) from the old Nagios XI to a different location on your new Nagios XI host, such as /tmp/perfdata_old</li>
						<li>Requires you to configure the Performance Data Tool to define the restored folder location such as /tmp/perfdata_old</li>
						<li>Refer to the Configure Tab on how to configure the Performance Data Tool</li>
					</ul>
					<li>With this type of Merge, the destination is always /usr/local/nagios/share/perfdata</li>
					<li>You can select between a "CaSe sEnSiTiVe mAtCh" or a "case insensitive match"</li>
				</ul>
			</ul>
			<div class="performancedatatool-spacer5"> </div>
			You can switch between the different Merge types without the Merge List being lost.
			
			<div class="performancedatatool-spacer10"> </div>
			<div class="performancedatatool-font-weight-bold">Perform Merge</div>
			<div class="performancedatatool-spacer20"> </div>
			When you click this button a popup window will appear showing you the realtime results of the merge action.
			<div class="performancedatatool-spacer10"> </div>
			<div class="performancedatatool-font-weight-bold">Admins vs Users</div>
			<div class="performancedatatool-spacer20"> </div>
			The Merge tab is only available to Admins. 
			<div class="performancedatatool-spacer15"> </div>
		</div> <!-- End Tab-Merge -->
		
		<div class="performancedatatool-spacer5"> </div>
		
		<div>
			<input type="button" class="performancedatatool-button01" onclick="performancedatatool_toggleMe(\'Tab-Delete\')" value="Delete">
		</div>
		<div id="Tab-Delete" style="display:none">
			<div class="performancedatatool-spacer5"> </div>
			This tab is very similar to the browse tab however here you can delete the RRD and XML files on your Nagios XI server. 
			<div class="performancedatatool-spacer5"> </div>
			This is helpful after decommissioning a device you were monitoring that you no longer need the performance data for.
			<div class="performancedatatool-spacer10"> </div>
			<div class="performancedatatool-font-weight-bold">NOTE: Destructive !!!!</div>
			<div class="performancedatatool-spacer20"> </div>
			Heed caution as deleting performance data CANNOT be reversed without a backup being taken beforehand!!!
			<div class="performancedatatool-spacer10"> </div>
			<div class="performancedatatool-font-weight-bold">Admins vs Users</div>
			<div class="performancedatatool-spacer20"> </div>
			The Delete tab is only available to Admins. 
			<div class="performancedatatool-spacer15"> </div>
		</div> <!-- End Tab-Delete -->

		<div class="performancedatatool-spacer5"> </div>
		
		<div>
			<input type="button" class="performancedatatool-button01" onclick="performancedatatool_toggleMe(\'Tab-Configure\')" value="Configure">
		</div>
		<div id="Tab-Configure" style="display:none">
			<div class="performancedatatool-spacer5"> </div>
			On your Nagios XI host, the location that the performance data files exists in is <b>/usr/local/nagios/share/perfdata</b>.
			<div class="performancedatatool-spacer5"> </div>
			The Performance Data Tool allows you to define Custom Folders where other performance data files reside on your Nagios XI host.
			<div class="performancedatatool-spacer5"> </div>
			The Confiure tab explains how you can add Custom Folders for the Performance Data Tool to use. 
			<div class="performancedatatool-spacer10"> </div>
			<div class="performancedatatool-font-weight-bold">Admins vs Users</div>
			<div class="performancedatatool-spacer20"> </div>
			The Configure tab is only available to Admins. 
			<div class="performancedatatool-spacer15"> </div>
		</div> <!-- End Tab-Configure -->

		<div class="performancedatatool-spacer5"> </div>
		
		<div>
			<input type="button" class="performancedatatool-button01" onclick="performancedatatool_toggleMe(\'Tab-Help\')" value="Help">
		</div>
		<div id="Tab-Help" style="display:none">
			<div class="performancedatatool-spacer5"> </div>
			You are on this tab now reading this :P
			<div class="performancedatatool-spacer15"> </div>
		</div> <!-- End Tab-Help -->

		<div class="performancedatatool-spacer5"> </div>

		<div>
			<input type="button" class="performancedatatool-button01" onclick="performancedatatool_toggleMe(\'DiscountOffer\')" value="Discount Offer">
		</div>
		<div id="DiscountOffer" style="display:none">
			<div class="performancedatatool-spacer5"> </div>
			Get a <b>10%</b> discount on your Nagios XI Unlimited Nodes license when purchased through <a href="http://www.nagios.com/nagiosxi10?ref=box293" target="_blank"><b>this link</b></a>.
			<div class="performancedatatool-spacer15"> </div>
		</div> <!-- End DiscountOffer -->
		
		<div class="performancedatatool-spacer5"> </div>

		<div>
			<input type="button" class="performancedatatool-button01" onclick="performancedatatool_toggleMe(\'Troubleshooting\')" value="Troubleshooting and Known Issues">
		</div>
		<div id="Troubleshooting" style="display:none">
			<div class="performancedatatool-spacer5"> </div>
			Various testing is performed on Windows 7 using Internet Explorer and Firefox as well as on LinuxMint 16 using Firefox.
			<div class="performancedatatool-spacer10"> </div>
			
			<div class="performancedatatool-font-weight-bold">Internet Explorer Issues</div>
			<div class="performancedatatool-spacer20"> </div>
			If something does not work in Internet Explorer try it in Firefox first before contacting me for support.
			<div class="performancedatatool-spacer5"> </div>
			This component works best when "Compatibility View" is DISABLED.
			<div class="performancedatatool-spacer5"> </div>
			
			<div class="performancedatatool-font-weight-bold">Table sorting does not always work</div>
			<div class="performancedatatool-spacer20"> </div>
			When results are displayed on the screen, sometimes with large numbers of entries they table does not sort properly. Simple click on the desired column to correctly sort them.
			<div class="performancedatatool-spacer5"> </div>
			
			<div class="performancedatatool-font-weight-bold">ERROR: This RRD was created on another architecture</div>
			<div class="performancedatatool-spacer20"> </div>
			A reason for this is that the RRD file was created on a different architecture. For example the rrd file was created on an x86 computer and now it is on an x64 computer.
			<div class="performancedatatool-spacer5"> </div>
			
			<div class="performancedatatool-spacer15"> </div>
		</div> <!-- End Troubleshooting -->

		<div class="performancedatatool-spacer5"> </div>
		
		<div>
			<input type="button" class="performancedatatool-button01" onclick="performancedatatool_toggleMe(\'Support\')" value="Support and Updates">
		</div>
		<div id="Support" style="display:none">
			<div class="performancedatatool-spacer5"> </div>
			Please contact me for support via the email address <a href="mailto:components@box293.com?Subject=Support%20Request:%20Peformance%20Data%20Tool" target="_top">components@box293.com</a>.
			<div class="performancedatatool-spacer5"> </div>
			I always announce product updates with a Tweet, my Twitter name is @box293. Please do NOT send support requests through Twitter.
			<div class="performancedatatool-spacer5"> </div>
			Please keep in mind that I do not charge for development and use of this component so support is provided on a best effort basis. Sometimes I will get back to you in a day, sometimes in a week!
			<div class="performancedatatool-spacer15"> </div>
		</div> <!-- End Tab-Help -->

		<div class="performancedatatool-spacer5"> </div>
		
		<div>
			<input type="button" class="performancedatatool-button01" onclick="performancedatatool_toggleMe(\'Work-In-Progress\')" value="Work In Progress">
		</div>
		<div id="Work-In-Progress" style="display:none">
			<div class="performancedatatool-spacer5"> </div>
			This is a list of items that have not been completed yet and plan to be addressed in the future.
			<div class="performancedatatool-spacer5"> </div>
			<div class="performancedatatool-spacer5"> </div>
			<div class="performancedatatool-font-weight-bold">Viewing RRD Data as graphs</div>
			<div class="performancedatatool-spacer20"> </div>
			This will be implemented in a future version. Funnily enough this was the main reason for creating this tool however due the usefulness of the merge functionality I chose to release it now and add this feature once I work it out!
			<div class="performancedatatool-spacer15"> </div>
		</div> <!-- End Work-In-Progress -->
		
		<div class="performancedatatool-spacer5"> </div>
		
		<div>
			<input type="button" class="performancedatatool-button01" onclick="performancedatatool_toggleMe(\'Project-Hours\')" value="Project Hours">
		</div>
		<div id="Project-Hours" style="display:none">
			<div class="performancedatatool-spacer5"> </div>
			Approximately 135 hours has been spent on this project. 
			<div class="performancedatatool-spacer15"> </div>
		</div> <!-- End Tab-License -->

		<div class="performancedatatool-spacer5"> </div>
		
		<div>
			<input type="button" class="performancedatatool-button01" onclick="return performancedatatool_toggleMe(\'My-Projects\')" value="My Projects">
		</div>
		<div id="My-Projects" style="display:none">
			<div class="performancedatatool-spacer5"> </div>
			I have created a handful of projects for Nagios XI for various reasons. Some of them are very useful indeed so I suggest you check them out, you can view them all here via <a href="http://exchange.nagios.org/directory/Owner/Box293/1" target="_blank">this link</a>.
			<div class="performancedatatool-spacer15"> </div>
		</div> <!-- End My-Projects -->
			
		<div class="performancedatatool-spacer5"> </div>
		
		<div>
			<input type="button" class="performancedatatool-button01" onclick="performancedatatool_toggleMe(\'Tab-License\')" value="License">
		</div>
		<div id="Tab-License" style="display:none">
			<div class="performancedatatool-spacer5"> </div>
			The License tab shows the license for this Component.
			<div class="performancedatatool-spacer15"> </div>
		</div> <!-- End Tab-License -->

		
	</div> <!-- End performancedatatool-help -->		

	
	<div id="performancedatatool-license" class="performancedatatool-togglediv" style="display:none">
	
		<h3 style="name-align: center;">GNU GENERAL PUBLIC LICENSE</h3>
		<p style="name-align: center;">Version 3, 29 June 2007</p>

		<p>Copyright &copy; 2007 Free Software Foundation, Inc.
		 &lt;<a href="http://fsf.org/">http://fsf.org/</a>&gt;</p><p>
		 Everyone is permitted to copy and distribute verbatim copies
		 of this license document, but changing it is not allowed.</p>

		<h3><a name="preamble"></a>Preamble</h3>

		<p>The GNU General Public License is a free, copyleft license for
		software and other kinds of works.</p>

		<p>The licenses for most software and other practical works are designed
		to take away your freedom to share and change the works.  By contrast,
		the GNU General Public License is intended to guarantee your freedom to
		share and change all versions of a program--to make sure it remains free
		software for all its users.  We, the Free Software Foundation, use the
		GNU General Public License for most of our software; it applies also to
		any other work released this way by its authors.  You can apply it to
		your programs, too.</p>

		<p>When we speak of free software, we are referring to freedom, not
		price.  Our General Public Licenses are designed to make sure that you
		have the freedom to distribute copies of free software (and charge for
		them if you wish), that you receive source code or can get it if you
		want it, that you can change the software or use pieces of it in new
		free programs, and that you know you can do these things.</p>

		<p>To protect your rights, we need to prevent others from denying you
		these rights or asking you to surrender the rights.  Therefore, you have
		certain responsibilities if you distribute copies of the software, or if
		you modify it: responsibilities to respect the freedom of others.</p>

		<p>For example, if you distribute copies of such a program, whether
		gratis or for a fee, you must pass on to the recipients the same
		freedoms that you received.  You must make sure that they, too, receive
		or can get the source code.  And you must show them these terms so they
		know their rights.</p>

		<p>Developers that use the GNU GPL protect your rights with two steps:
		(1) assert copyright on the software, and (2) offer you this License
		giving you legal permission to copy, distribute and/or modify it.</p>

		<p>For the developers\' and authors\' protection, the GPL clearly explains
		that there is no warranty for this free software.  For both users\' and
		authors\' sake, the GPL requires that modified versions be marked as
		changed, so that their problems will not be attributed erroneously to
		authors of previous versions.</p>

		<p>Some devices are designed to deny users access to install or run
		modified versions of the software inside them, although the manufacturer
		can do so.  This is fundamentally incompatible with the aim of
		protecting users\' freedom to change the software.  The systematic
		pattern of such abuse occurs in the area of products for individuals to
		use, which is precisely where it is most unacceptable.  Therefore, we
		have designed this version of the GPL to prohibit the practice for those
		products.  If such problems arise substantially in other domains, we
		stand ready to extend this provision to those domains in future versions
		of the GPL, as needed to protect the freedom of users.</p>

		<p>Finally, every program is threatened constantly by software patents.
		States should not allow patents to restrict development and use of
		software on general-purpose computers, but in those that do, we wish to
		avoid the special danger that patents applied to a free program could
		make it effectively proprietary.  To prevent this, the GPL assures that
		patents cannot be used to render the program non-free.</p>

		<p>The precise terms and conditions for copying, distribution and
		modification follow.</p>

		<h3><a name="terms"></a>TERMS AND CONDITIONS</h3>

		<h4><a name="section0"></a>0. Definitions.</h4>

		<p>&ldquo;This License&rdquo; refers to version 3 of the GNU General Public License.</p>

		<p>&ldquo;Copyright&rdquo; also means copyright-like laws that apply to other kinds of
		works, such as semiconductor masks.</p>
		 
		<p>&ldquo;The Program&rdquo; refers to any copyrightable work licensed under this
		License.  Each licensee is addressed as &ldquo;you&rdquo;.  &ldquo;Licensees&rdquo; and
		&ldquo;recipients&rdquo; may be individuals or organizations.</p>

		<p>To &ldquo;modify&rdquo; a work means to copy from or adapt all or part of the work
		in a fashion requiring copyright permission, other than the making of an
		exact copy.  The resulting work is called a &ldquo;modified version&rdquo; of the
		earlier work or a work &ldquo;based on&rdquo; the earlier work.</p>

		<p>A &ldquo;covered work&rdquo; means either the unmodified Program or a work based
		on the Program.</p>

		<p>To &ldquo;propagate&rdquo; a work means to do anything with it that, without
		permission, would make you directly or secondarily liable for
		infringement under applicable copyright law, except executing it on a
		computer or modifying a private copy.  Propagation includes copying,
		distribution (with or without modification), making available to the
		public, and in some countries other activities as well.</p>

		<p>To &ldquo;convey&rdquo; a work means any kind of propagation that enables other
		parties to make or receive copies.  Mere interaction with a user through
		a computer network, with no transfer of a copy, is not conveying.</p>

		<p>An interactive user interface displays &ldquo;Appropriate Legal Notices&rdquo;
		to the extent that it includes a convenient and prominently visible
		feature that (1) displays an appropriate copyright notice, and (2)
		tells the user that there is no warranty for the work (except to the
		extent that warranties are provided), that licensees may convey the
		work under this License, and how to view a copy of this License.  If
		the interface presents a list of user commands or options, such as a
		menu, a prominent item in the list meets this criterion.</p>

		<h4><a name="section1"></a>1. Source Code.</h4>

		<p>The &ldquo;source code&rdquo; for a work means the preferred form of the work
		for making modifications to it.  &ldquo;Object code&rdquo; means any non-source
		form of a work.</p>

		<p>A &ldquo;Standard Interface&rdquo; means an interface that either is an official
		standard defined by a recognized standards body, or, in the case of
		interfaces specified for a particular programming language, one that
		is widely used among developers working in that language.</p>

		<p>The &ldquo;System Libraries&rdquo; of an executable work include anything, other
		than the work as a whole, that (a) is included in the normal form of
		packaging a Major Component, but which is not part of that Major
		Component, and (b) serves only to enable use of the work with that
		Major Component, or to implement a Standard Interface for which an
		implementation is available to the public in source code form.  A
		&ldquo;Major Component&rdquo;, in this conname, means a major essential component
		(kernel, window system, and so on) of the specific operating system
		(if any) on which the executable work runs, or a compiler used to
		produce the work, or an object code interpreter used to run it.</p>

		<p>The &ldquo;Corresponding Source&rdquo; for a work in object code form means all
		the source code needed to generate, install, and (for an executable
		work) run the object code and to modify the work, including scripts to
		control those activities.  However, it does not include the work\'s
		System Libraries, or general-purpose tools or generally available free
		programs which are used unmodified in performing those activities but
		which are not part of the work.  For example, Corresponding Source
		includes interface definition files associated with source files for
		the work, and the source code for shared libraries and dynamically
		linked subprograms that the work is specifically designed to require,
		such as by intimate data communication or control flow between those
		subprograms and other parts of the work.</p>

		<p>The Corresponding Source need not include anything that users
		can regenerate automatically from other parts of the Corresponding
		Source.</p>

		<p>The Corresponding Source for a work in source code form is that
		same work.</p>

		<h4><a name="section2"></a>2. Basic Permissions.</h4>

		<p>All rights granted under this License are granted for the term of
		copyright on the Program, and are irrevocable provided the stated
		conditions are met.  This License explicitly affirms your unlimited
		permission to run the unmodified Program.  The output from running a
		covered work is covered by this License only if the output, given its
		content, constitutes a covered work.  This License acknowledges your
		rights of fair use or other equivalent, as provided by copyright law.</p>

		<p>You may make, run and propagate covered works that you do not
		convey, without conditions so long as your license otherwise remains
		in force.  You may convey covered works to others for the sole purpose
		of having them make modifications exclusively for you, or provide you
		with facilities for running those works, provided that you comply with
		the terms of this License in conveying all material for which you do
		not control copyright.  Those thus making or running the covered works
		for you must do so exclusively on your behalf, under your direction
		and control, on terms that prohibit them from making any copies of
		your copyrighted material outside their relationship with you.</p>

		<p>Conveying under any other circumstances is permitted solely under
		the conditions stated below.  Sublicensing is not allowed; section 10
		makes it unnecessary.</p>

		<h4><a name="section3"></a>3. Protecting Users\' Legal Rights From Anti-Circumvention Law.</h4>

		<p>No covered work shall be deemed part of an effective technological
		measure under any applicable law fulfilling obligations under article
		11 of the WIPO copyright treaty adopted on 20 December 1996, or
		similar laws prohibiting or restricting circumvention of such
		measures.</p>

		<p>When you convey a covered work, you waive any legal power to forbid
		circumvention of technological measures to the extent such circumvention
		is effected by exercising rights under this License with respect to
		the covered work, and you disclaim any intention to limit operation or
		modification of the work as a means of enforcing, against the work\'s
		users, your or third parties\' legal rights to forbid circumvention of
		technological measures.</p>

		<h4><a name="section4"></a>4. Conveying Verbatim Copies.</h4>

		<p>You may convey verbatim copies of the Program\'s source code as you
		receive it, in any medium, provided that you conspicuously and
		appropriately publish on each copy an appropriate copyright notice;
		keep intact all notices stating that this License and any
		non-permissive terms added in accord with section 7 apply to the code;
		keep intact all notices of the absence of any warranty; and give all
		recipients a copy of this License along with the Program.</p>

		<p>You may charge any price or no price for each copy that you convey,
		and you may offer support or warranty protection for a fee.</p>

		<h4><a name="section5"></a>5. Conveying Modified Source Versions.</h4>

		<p>You may convey a work based on the Program, or the modifications to
		produce it from the Program, in the form of source code under the
		terms of section 4, provided that you also meet all of these conditions:</p>

		<ul>
		<li>a) The work must carry prominent notices stating that you modified
			it, and giving a relevant date.</li>

		<li>b) The work must carry prominent notices stating that it is
			released under this License and any conditions added under section
			7.  This requirement modifies the requirement in section 4 to
			&ldquo;keep intact all notices&rdquo;.</li>

		<li>c) You must license the entire work, as a whole, under this
			License to anyone who comes into possession of a copy.  This
			License will therefore apply, along with any applicable section 7
			additional terms, to the whole of the work, and all its parts,
			regardless of how they are packaged.  This License gives no
			permission to license the work in any other way, but it does not
			invalidate such permission if you have separately received it.</li>

		<li>d) If the work has interactive user interfaces, each must display
			Appropriate Legal Notices; however, if the Program has interactive
			interfaces that do not display Appropriate Legal Notices, your
			work need not make them do so.</li>
		</ul>

		<p>A compilation of a covered work with other separate and independent
		works, which are not by their nature extensions of the covered work,
		and which are not combined with it such as to form a larger program,
		in or on a volume of a storage or distribution medium, is called an
		&ldquo;aggregate&rdquo; if the compilation and its resulting copyright are not
		used to limit the access or legal rights of the compilation\'s users
		beyond what the individual works permit.  Inclusion of a covered work
		in an aggregate does not cause this License to apply to the other
		parts of the aggregate.</p>

		<h4><a name="section6"></a>6. Conveying Non-Source Forms.</h4>

		<p>You may convey a covered work in object code form under the terms
		of sections 4 and 5, provided that you also convey the
		machine-readable Corresponding Source under the terms of this License,
		in one of these ways:</p>

		<ul>
		<li>a) Convey the object code in, or embodied in, a physical product
			(including a physical distribution medium), accompanied by the
			Corresponding Source fixed on a durable physical medium
			customarily used for software interchange.</li>

		<li>b) Convey the object code in, or embodied in, a physical product
			(including a physical distribution medium), accompanied by a
			written offer, valid for at least three years and valid for as
			long as you offer spare parts or customer support for that product
			model, to give anyone who possesses the object code either (1) a
			copy of the Corresponding Source for all the software in the
			product that is covered by this License, on a durable physical
			medium customarily used for software interchange, for a price no
			more than your reasonable cost of physically performing this
			conveying of source, or (2) access to copy the
			Corresponding Source from a network server at no charge.</li>

		<li>c) Convey individual copies of the object code with a copy of the
			written offer to provide the Corresponding Source.  This
			alternative is allowed only occasionally and noncommercially, and
			only if you received the object code with such an offer, in accord
			with subsection 6b.</li>

		<li>d) Convey the object code by offering access from a designated
			place (gratis or for a charge), and offer equivalent access to the
			Corresponding Source in the same way through the same place at no
			further charge.  You need not require recipients to copy the
			Corresponding Source along with the object code.  If the place to
			copy the object code is a network server, the Corresponding Source
			may be on a different server (operated by you or a third party)
			that supports equivalent copying facilities, provided you maintain
			clear directions next to the object code saying where to find the
			Corresponding Source.  Regardless of what server hosts the
			Corresponding Source, you remain obligated to ensure that it is
			available for as long as needed to satisfy these requirements.</li>

		<li>e) Convey the object code using peer-to-peer transmission, provided
			you inform other peers where the object code and Corresponding
			Source of the work are being offered to the general public at no
			charge under subsection 6d.</li>
		</ul>

		<p>A separable portion of the object code, whose source code is excluded
		from the Corresponding Source as a System Library, need not be
		included in conveying the object code work.</p>

		<p>A &ldquo;User Product&rdquo; is either (1) a &ldquo;consumer product&rdquo;, which means any
		tangible personal property which is normally used for personal, family,
		or household purposes, or (2) anything designed or sold for incorporation
		into a dwelling.  In determining whether a product is a consumer product,
		doubtful cases shall be resolved in favor of coverage.  For a particular
		product received by a particular user, &ldquo;normally used&rdquo; refers to a
		typical or common use of that class of product, regardless of the status
		of the particular user or of the way in which the particular user
		actually uses, or expects or is expected to use, the product.  A product
		is a consumer product regardless of whether the product has substantial
		commercial, industrial or non-consumer uses, unless such uses represent
		the only significant mode of use of the product.</p>

		<p>&ldquo;Installation Information&rdquo; for a User Product means any methods,
		procedures, authorization keys, or other information required to install
		and execute modified versions of a covered work in that User Product from
		a modified version of its Corresponding Source.  The information must
		suffice to ensure that the continued functioning of the modified object
		code is in no case prevented or interfered with solely because
		modification has been made.</p>

		<p>If you convey an object code work under this section in, or with, or
		specifically for use in, a User Product, and the conveying occurs as
		part of a transaction in which the right of possession and use of the
		User Product is transferred to the recipient in perpetuity or for a
		fixed term (regardless of how the transaction is characterized), the
		Corresponding Source conveyed under this section must be accompanied
		by the Installation Information.  But this requirement does not apply
		if neither you nor any third party retains the ability to install
		modified object code on the User Product (for example, the work has
		been installed in ROM).</p>

		<p>The requirement to provide Installation Information does not include a
		requirement to continue to provide support service, warranty, or updates
		for a work that has been modified or installed by the recipient, or for
		the User Product in which it has been modified or installed.  Access to a
		network may be denied when the modification itself materially and
		adversely affects the operation of the network or violates the rules and
		protocols for communication across the network.</p>

		<p>Corresponding Source conveyed, and Installation Information provided,
		in accord with this section must be in a format that is publicly
		documented (and with an implementation available to the public in
		source code form), and must require no special password or key for
		unpacking, reading or copying.</p>

		<h4><a name="section7"></a>7. Additional Terms.</h4>

		<p>&ldquo;Additional permissions&rdquo; are terms that supplement the terms of this
		License by making exceptions from one or more of its conditions.
		Additional permissions that are applicable to the entire Program shall
		be treated as though they were included in this License, to the extent
		that they are valid under applicable law.  If additional permissions
		apply only to part of the Program, that part may be used separately
		under those permissions, but the entire Program remains governed by
		this License without regard to the additional permissions.</p>

		<p>When you convey a copy of a covered work, you may at your option
		remove any additional permissions from that copy, or from any part of
		it.  (Additional permissions may be written to require their own
		removal in certain cases when you modify the work.)  You may place
		additional permissions on material, added by you to a covered work,
		for which you have or can give appropriate copyright permission.</p>

		<p>Notwithstanding any other provision of this License, for material you
		add to a covered work, you may (if authorized by the copyright holders of
		that material) supplement the terms of this License with terms:</p>

		<ul>
		<li>a) Disclaiming warranty or limiting liability differently from the
			terms of sections 15 and 16 of this License; or</li>

		<li>b) Requiring preservation of specified reasonable legal notices or
			author attributions in that material or in the Appropriate Legal
			Notices displayed by works containing it; or</li>

		<li>c) Prohibiting misrepresentation of the origin of that material, or
			requiring that modified versions of such material be marked in
			reasonable ways as different from the original version; or</li>

		<li>d) Limiting the use for publicity purposes of names of licensors or
			authors of the material; or</li>

		<li>e) Declining to grant rights under trademark law for use of some
			trade names, trademarks, or service marks; or</li>

		<li>f) Requiring indemnification of licensors and authors of that
			material by anyone who conveys the material (or modified versions of
			it) with contractual assumptions of liability to the recipient, for
			any liability that these contractual assumptions directly impose on
			those licensors and authors.</li>
		</ul>

		<p>All other non-permissive additional terms are considered &ldquo;further
		restrictions&rdquo; within the meaning of section 10.  If the Program as you
		received it, or any part of it, contains a notice stating that it is
		governed by this License along with a term that is a further
		restriction, you may remove that term.  If a license document contains
		a further restriction but permits relicensing or conveying under this
		License, you may add to a covered work material governed by the terms
		of that license document, provided that the further restriction does
		not survive such relicensing or conveying.</p>

		<p>If you add terms to a covered work in accord with this section, you
		must place, in the relevant source files, a statement of the
		additional terms that apply to those files, or a notice indicating
		where to find the applicable terms.</p>

		<p>Additional terms, permissive or non-permissive, may be stated in the
		form of a separately written license, or stated as exceptions;
		the above requirements apply either way.</p>

		<h4><a name="section8"></a>8. Termination.</h4>

		<p>You may not propagate or modify a covered work except as expressly
		provided under this License.  Any attempt otherwise to propagate or
		modify it is void, and will automatically terminate your rights under
		this License (including any patent licenses granted under the third
		paragraph of section 11).</p>

		<p>However, if you cease all violation of this License, then your
		license from a particular copyright holder is reinstated (a)
		provisionally, unless and until the copyright holder explicitly and
		finally terminates your license, and (b) permanently, if the copyright
		holder fails to notify you of the violation by some reasonable means
		prior to 60 days after the cessation.</p>

		<p>Moreover, your license from a particular copyright holder is
		reinstated permanently if the copyright holder notifies you of the
		violation by some reasonable means, this is the first time you have
		received notice of violation of this License (for any work) from that
		copyright holder, and you cure the violation prior to 30 days after
		your receipt of the notice.</p>

		<p>Termination of your rights under this section does not terminate the
		licenses of parties who have received copies or rights from you under
		this License.  If your rights have been terminated and not permanently
		reinstated, you do not qualify to receive new licenses for the same
		material under section 10.</p>

		<h4><a name="section9"></a>9. Acceptance Not Required for Having Copies.</h4>

		<p>You are not required to accept this License in order to receive or
		run a copy of the Program.  Ancillary propagation of a covered work
		occurring solely as a consequence of using peer-to-peer transmission
		to receive a copy likewise does not require acceptance.  However,
		nothing other than this License grants you permission to propagate or
		modify any covered work.  These actions infringe copyright if you do
		not accept this License.  Therefore, by modifying or propagating a
		covered work, you indicate your acceptance of this License to do so.</p>

		<h4><a name="section10"></a>10. Automatic Licensing of Downstream Recipients.</h4>

		<p>Each time you convey a covered work, the recipient automatically
		receives a license from the original licensors, to run, modify and
		propagate that work, subject to this License.  You are not responsible
		for enforcing compliance by third parties with this License.</p>

		<p>An &ldquo;entity transaction&rdquo; is a transaction transferring control of an
		organization, or substantially all assets of one, or subdividing an
		organization, or merging organizations.  If propagation of a covered
		work results from an entity transaction, each party to that
		transaction who receives a copy of the work also receives whatever
		licenses to the work the party\'s predecessor in interest had or could
		give under the previous paragraph, plus a right to possession of the
		Corresponding Source of the work from the predecessor in interest, if
		the predecessor has it or can get it with reasonable efforts.</p>

		<p>You may not impose any further restrictions on the exercise of the
		rights granted or affirmed under this License.  For example, you may
		not impose a license fee, royalty, or other charge for exercise of
		rights granted under this License, and you may not initiate litigation
		(including a cross-claim or counterclaim in a lawsuit) alleging that
		any patent claim is infringed by making, using, selling, offering for
		sale, or importing the Program or any portion of it.</p>

		<h4><a name="section11"></a>11. Patents.</h4>

		<p>A &ldquo;contributor&rdquo; is a copyright holder who authorizes use under this
		License of the Program or a work on which the Program is based.  The
		work thus licensed is called the contributor\'s &ldquo;contributor version&rdquo;.</p>

		<p>A contributor\'s &ldquo;essential patent claims&rdquo; are all patent claims
		owned or controlled by the contributor, whether already acquired or
		hereafter acquired, that would be infringed by some manner, permitted
		by this License, of making, using, or selling its contributor version,
		but do not include claims that would be infringed only as a
		consequence of further modification of the contributor version.  For
		purposes of this definition, &ldquo;control&rdquo; includes the right to grant
		patent sublicenses in a manner consistent with the requirements of
		this License.</p>

		<p>Each contributor grants you a non-exclusive, worldwide, royalty-free
		patent license under the contributor\'s essential patent claims, to
		make, use, sell, offer for sale, import and otherwise run, modify and
		propagate the contents of its contributor version.</p>

		<p>In the following three paragraphs, a &ldquo;patent license&rdquo; is any express
		agreement or commitment, however denominated, not to enforce a patent
		(such as an express permission to practice a patent or covenant not to
		sue for patent infringement).  To &ldquo;grant&rdquo; such a patent license to a
		party means to make such an agreement or commitment not to enforce a
		patent against the party.</p>

		<p>If you convey a covered work, knowingly relying on a patent license,
		and the Corresponding Source of the work is not available for anyone
		to copy, free of charge and under the terms of this License, through a
		publicly available network server or other readily accessible means,
		then you must either (1) cause the Corresponding Source to be so
		available, or (2) arrange to deprive yourself of the benefit of the
		patent license for this particular work, or (3) arrange, in a manner
		consistent with the requirements of this License, to extend the patent
		license to downstream recipients.  &ldquo;Knowingly relying&rdquo; means you have
		actual knowledge that, but for the patent license, your conveying the
		covered work in a country, or your recipient\'s use of the covered work
		in a country, would infringe one or more identifiable patents in that
		country that you have reason to believe are valid.</p>
		  
		<p>If, pursuant to or in connection with a single transaction or
		arrangement, you convey, or propagate by procuring conveyance of, a
		covered work, and grant a patent license to some of the parties
		receiving the covered work authorizing them to use, propagate, modify
		or convey a specific copy of the covered work, then the patent license
		you grant is automatically extended to all recipients of the covered
		work and works based on it.</p>

		<p>A patent license is &ldquo;discriminatory&rdquo; if it does not include within
		the scope of its coverage, prohibits the exercise of, or is
		conditioned on the non-exercise of one or more of the rights that are
		specifically granted under this License.  You may not convey a covered
		work if you are a party to an arrangement with a third party that is
		in the business of distributing software, under which you make payment
		to the third party based on the extent of your activity of conveying
		the work, and under which the third party grants, to any of the
		parties who would receive the covered work from you, a discriminatory
		patent license (a) in connection with copies of the covered work
		conveyed by you (or copies made from those copies), or (b) primarily
		for and in connection with specific products or compilations that
		contain the covered work, unless you entered into that arrangement,
		or that patent license was granted, prior to 28 March 2007.</p>

		<p>Nothing in this License shall be construed as excluding or limiting
		any implied license or other defenses to infringement that may
		otherwise be available to you under applicable patent law.</p>

		<h4><a name="section12"></a>12. No Surrender of Others\' Freedom.</h4>

		<p>If conditions are imposed on you (whether by court order, agreement or
		otherwise) that contradict the conditions of this License, they do not
		excuse you from the conditions of this License.  If you cannot convey a
		covered work so as to satisfy simultaneously your obligations under this
		License and any other pertinent obligations, then as a consequence you may
		not convey it at all.  For example, if you agree to terms that obligate you
		to collect a royalty for further conveying from those to whom you convey
		the Program, the only way you could satisfy both those terms and this
		License would be to refrain entirely from conveying the Program.</p>

		<h4><a name="section13"></a>13. Use with the GNU Affero General Public License.</h4>

		<p>Notwithstanding any other provision of this License, you have
		permission to link or combine any covered work with a work licensed
		under version 3 of the GNU Affero General Public License into a single
		combined work, and to convey the resulting work.  The terms of this
		License will continue to apply to the part which is the covered work,
		but the special requirements of the GNU Affero General Public License,
		section 13, concerning interaction through a network will apply to the
		combination as such.</p>

		<h4><a name="section14"></a>14. Revised Versions of this License.</h4>

		<p>The Free Software Foundation may publish revised and/or new versions of
		the GNU General Public License from time to time.  Such new versions will
		be similar in spirit to the present version, but may differ in detail to
		address new problems or concerns.</p>

		<p>Each version is given a distinguishing version number.  If the
		Program specifies that a certain numbered version of the GNU General
		Public License &ldquo;or any later version&rdquo; applies to it, you have the
		option of following the terms and conditions either of that numbered
		version or of any later version published by the Free Software
		Foundation.  If the Program does not specify a version number of the
		GNU General Public License, you may choose any version ever published
		by the Free Software Foundation.</p>

		<p>If the Program specifies that a proxy can decide which future
		versions of the GNU General Public License can be used, that proxy\'s
		public statement of acceptance of a version permanently authorizes you
		to choose that version for the Program.</p>

		<p>Later license versions may give you additional or different
		permissions.  However, no additional obligations are imposed on any
		author or copyright holder as a result of your choosing to follow a
		later version.</p>

		<h4><a name="section15"></a>15. Disclaimer of Warranty.</h4>

		<p>THERE IS NO WARRANTY FOR THE PROGRAM, TO THE EXTENT PERMITTED BY
		APPLICABLE LAW.  EXCEPT WHEN OTHERWISE STATED IN WRITING THE COPYRIGHT
		HOLDERS AND/OR OTHER PARTIES PROVIDE THE PROGRAM &ldquo;AS IS&rdquo; WITHOUT WARRANTY
		OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING, BUT NOT LIMITED TO,
		THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
		PURPOSE.  THE ENTIRE RISK AS TO THE QUALITY AND PERFORMANCE OF THE PROGRAM
		IS WITH YOU.  SHOULD THE PROGRAM PROVE DEFECTIVE, YOU ASSUME THE COST OF
		ALL NECESSARY SERVICING, REPAIR OR CORRECTION.</p>

		<h4><a name="section16"></a>16. Limitation of Liability.</h4>

		<p>IN NO EVENT UNLESS REQUIRED BY APPLICABLE LAW OR AGREED TO IN WRITING
		WILL ANY COPYRIGHT HOLDER, OR ANY OTHER PARTY WHO MODIFIES AND/OR CONVEYS
		THE PROGRAM AS PERMITTED ABOVE, BE LIABLE TO YOU FOR DAMAGES, INCLUDING ANY
		GENERAL, SPECIAL, INCIDENTAL OR CONSEQUENTIAL DAMAGES ARISING OUT OF THE
		USE OR INABILITY TO USE THE PROGRAM (INCLUDING BUT NOT LIMITED TO LOSS OF
		DATA OR DATA BEING RENDERED INACCURATE OR LOSSES SUSTAINED BY YOU OR THIRD
		PARTIES OR A FAILURE OF THE PROGRAM TO OPERATE WITH ANY OTHER PROGRAMS),
		EVEN IF SUCH HOLDER OR OTHER PARTY HAS BEEN ADVISED OF THE POSSIBILITY OF
		SUCH DAMAGES.</p>

		<h4><a name="section17"></a>17. Interpretation of Sections 15 and 16.</h4>

		<p>If the disclaimer of warranty and limitation of liability provided
		above cannot be given local legal effect according to their terms,
		reviewing courts shall apply local law that most closely approximates
		an absolute waiver of all civil liability in connection with the
		Program, unless a warranty or assumption of liability accompanies a
		copy of the Program in return for a fee.</p>

		<p>END OF TERMS AND CONDITIONS</p>
		<br />
	</div> <!-- End performancedatatool-license -->		

	
		
	';
	
	$html .= '</body>';
	$html .= '</html>';
	
	return $html; 
	} /* End function performancedatatool_build_html() { */

	
function draw_select_of_date_filters($type) {
	$date_filter_type_name = 'date_filters_' . $type;
	$date_filter_type_id = 'id_date_filters_' . $type;
	$return_select = '
		<select name="'.$date_filter_type_name.'" id="'.$date_filter_type_id.'" title="Filter the results based on a time period" onChange="performancedatatool_draw_table(\''.$type.'\')">
			<option value="all" selected>All Files</option>
			<option value="1m">Files older than 1 Month</option>
			<option value="3m">Files older than 3 Months</option>
			<option value="6m">Files older than 6 Months</option>
			<option value="9m">Files older than 9 Months</option>
			<option value="12m">Files older than 1 Year</option>
			<option value="15m">Files older than 1.25 Years</option>
			<option value="18m">Files older than 1.5 Years</option>
			<option value="21m">Files older than 1.75 Years</option>
			<option value="24m">Files older than 2 Years</option>
		</select>';
	return $return_select;
	} /* End function draw_select_of_date_filters() { */

	
function draw_select_of_merge_types() {
	/* Check to see if the setting for custom folders are defined */
	/* This was specifically added for the structure merge */
	$settings_raw = get_option('performancedatatool_component_options');
	if($settings_raw == '') {
		/* There are currently no settings */
		$settings = 'none-defined';
		} /* End if($settings_raw == '') { */
	else {
		/* Settings are defined so unserialize them */
		$settings = unserialize($settings_raw);
		/* Get the folders_list */
		$folders_list = grab_array_var($settings,'folders_list','');
		/* Check to see if any custom folders have been defined */
		if (empty($folders_list)) {
			$settings = 'none-defined';
			} /* End if (empty($folders_list)) { */
		else {
			/* We are only interested in type1 folders */
			$settings_test = 0;
			foreach ($folders_list as $nested_array) {
				if ($nested_array[1] == 'type1') {
					$settings_test = 1;
					} /* End if ($nested_array[1] == 'type1') { */
				} /* End foreach ($folders_list as $nested_array) { */
			if ($settings_test == 1) {
				$settings = 'defined';
				} /* End if ($settings_test == 1) { */
			else {
				$settings = 'none-defined';
				} /* End else { */
			} /* End else { */
		} /* End else { */

	$merge_name = 'merge';
	$merge_id = 'id_merge';
	$merge_select = '
		<select name="'.$merge_name.'" id="'.$merge_id.'" title="Select a merge type" onChange="performancedatatool_merge_type(\''.$settings.'\')">
			<option value="" selected></option>
			<option value="specific">Merge specific .rrd\'s</option>
			<option value="folder">Merge all .rrd\'s in one folder into all .rrd\'s in another folder</option>
			<option value="structure">Merge entire folder structure of .rrd\'s into perfdata folder</option>
		</select>';
	return $merge_select;
	} /* End function draw_select_of_merge_types() { */

