<?php  
// performance_data_tool_actions COMPONENT
//
// Copyright 2016-05-05 Troy Lea aka Box293
//

require_once(dirname(__FILE__).'/../../common.inc.php');

// initialization stuff
pre_init();
// start session
init_session();
// grab GET or POST variables 
grab_request_vars();
// check prereqs
check_prereqs();
// check authentication
check_authentication(false);

	
/* Build the HTML content */
$html = performancedatatool_actions();
print $html; 


/* FUNCTIONS */

function performancedatatool_actions() {
	$html = '';
	
	/* Get the action passed to us */
	$performancedatatool_action = urldecode(grab_request_var('action',false));
	
	/* Perform the action type */
	switch ($performancedatatool_action) {
		case 'delete':
			/* Get the action_selected passed to us */
			$performancedatatool_action_selected = urldecode(grab_request_var('action_selected',false));
	
			/* Perform the action_selected */
			switch ($performancedatatool_action_selected) {
				case 'delete_selected_items':
					/* Get the delete_folder_name passed to us */
					$delete_folder_name = urldecode(grab_request_var('delete_folder_name',false));
					//print_r('delete_folder_name ' . $delete_folder_name . '<br/><br/>');
					/* Get the delete_folder_location passed to us */
					$delete_folder_location = urldecode(urldecode(grab_request_var('delete_folder_location',false)));
					//print_r('delete_folder_location ' . $delete_folder_location . '<br/><br/>');
					/* Get the delete_file_name passed to us */
					$delete_file_name = urldecode(grab_request_var('delete_file_name',false));
					//print_r('delete_file_name ' . $delete_file_name . '<br/><br/>');

					/* Defining current file */
					if (strpos($delete_file_name, '..', 0 === 0)) {
						$current_file = realpath($delete_file_name);
						} /* End if (strpos($delete_file_name, '..', 0 === 0)) { */
					elseif ($delete_folder_location != '../../../../../nagios/share/perfdata/') {
						$current_file = realpath($delete_file_name);
						} /* End elseif ($delete_folder_location != '../../../../../nagios/share/perfdata/') { */
					else {
						switch ($delete_folder_location) {
							case '../../../../../nagios/share/perfdata/':
								$current_file = realpath('../../../../../nagios/share/perfdata/'.$delete_folder_name.'/'.$delete_file_name);
								break; /* End case '../../../../../nagios/share/perfdata/': */
							
							default:
								$current_file = realpath($delete_folder_location . '/'.$delete_folder_name.'/'.$delete_file_name);
								break; /* End default: */
							} /* End switch ($delete_folder_location) { */
						} /* End else { */
					
					/* Show some information */
					$html .= '<hr>';
					$html .= 'Deleting file: '.$current_file.'<br />';
					$html .= 'Result: ';
					
					/* Defining Delete Command */
					$delete_command = 'rm -f -v "' . $current_file . '" 2>&1 ';
					/* Executing Delete Command */
					$delete_output = shell_exec($delete_command);
					
					/* Outputting Results */
					switch ($delete_output) {
						case (substr_compare($delete_output, 'Permission denied', -strlen('Permission denied'), strlen('Permission denied')) === 0):
							$html .= 'ERROR: '.$delete_output.'<br />';
							break; /* End case (substr_compare($delete_output, 'Permission denied', -strlen('Permission denied'), strlen('Permission denied')) === 0): */
						
						case (strpos($delete_output, 'removed') === 0):
						default:
							$html .= $delete_output.'<br />';
							break; /* End (strpos($delete_output, 'removed') === 0): and default: */
						
						} /* End switch ($delete_output) { */					
					break; /* End case 'delete_selected_items': */
				
				
				case 'delete_folder':
					/* Get the foldername passed to us */
					$performancedatatool_delete_foldername = urldecode(grab_request_var('foldername',false));
					/* Get the folderlocation passed to us */
					$performancedatatool_delete_folderlocation = urldecode(urldecode(grab_request_var('folderlocation',false)));
					
					/* Defining folder */
					switch ($performancedatatool_delete_folderlocation) {
						case '../../../../../nagios/share/perfdata/':
							$current_folder = realpath('../../../../../nagios/share/perfdata/'.$performancedatatool_delete_foldername);
							break; /* End case '../../../../../nagios/share/perfdata/': */
						
						default:
							$current_folder = realpath($performancedatatool_delete_folderlocation . '/' .$performancedatatool_delete_foldername);
							break; /* End default: */
						} /* End switch ($delete_folder_location) { */
					
					/* Counting the number of files in the folder */
					/* Defining Count Command */
					$count_command = 'find "' . $current_folder . '" -type f | wc -l';
					/* Executing Count Command */
					$count_output = shell_exec($count_command);
					//print_r('count_output ' . $count_output . '<br/><br/>');
					
					$html .= '<hr>';
					$html .= 'Deleting FOLDER and CONTENTS: '.$current_folder.'<br />';
					/* Defining Delete Command */
					$delete_command = 'rm -f -R -v "' . $current_folder . '" 2>&1 ';
					/* Executing Delete Command */
					exec($delete_command, $delete_output);
					
					/* Outputting Results */
					foreach ($delete_output as $output_line) {
						switch ($output_line) {
							case (substr_compare($output_line, 'Permission denied', -strlen('Permission denied'), strlen('Permission denied')) === 0):
								$html .= 'ERROR: '.$output_line.'<br />';
								break; /* End case (substr_compare($output_line, 'Permission denied', -strlen('Permission denied'), strlen('Permission denied')) === 0): */
							
							case (strpos($output_line, 'removed') === 0):	
							default:
								$html .= $output_line.'<br />';
								break; /* End case (strpos($output_line, 'removed') === 0):	and default: */
							
							} /* End switch ($output_line) { */
						} /* End foreach ($merge_output as $output_line) { */	
					
					/* This is for the progress */
					if ($count_output > 1) {
						$item_word = 'items';
						} /* End if ($count_output > 1) { */
					elseif ($count_output > 0) {
						$item_word = 'item';
						} /* End elseif ($count_output > 0) { */
					else {
						$item_word = 'none';
						} /* End else { */
					
					$html .= '
						<input type="hidden" name="performancedatatool_delete_folder_count_output" id="id_performancedatatool_delete_folder_count_output" value="'.$count_output.'">
						<input type="hidden" name="performancedatatool_delete_folder_item_word" id="id_performancedatatool_delete_folder_item_word" value="'.$item_word.'">
						';
					break; /* End case 'delete_folder': */
				} /* End switch ($performancedatatool_action) { */
			break; /* End case 'delete': */
		
		case 'merge':
			/* Get the merge_type_selected passed to us */
			$performancedatatool_action_merge_type_selected = grab_request_var('merge_type_selected',false);
			switch ($performancedatatool_action_merge_type_selected) {
				case 'specific':
				case 'folder':
				case 'structure':
					/* Get the merge_source passed to us */
					$merge_source = urldecode(urldecode(grab_request_var('merge_source',false)));
					/* Get the merge_destination passed to us */
					$merge_destination = urldecode(urldecode(grab_request_var('merge_destination',false)));
					
					/* Defining the Source and Destination Files */
					//$merge_source = realpath('../../../../../nagios/share/perfdata/'.$merge_source);
					//$merge_destination = realpath('../../../../../nagios/share/perfdata/'.$merge_destination);
					
					/* Show some information */
					$html .= '<hr>';
					$html .= 'Merging: '.$merge_source.' ---> '.$merge_destination.'<br />';
					$html .= 'Result:<br />';
					
					/* Defining Merge Command */
					//$merge_command = 'scripts/rrdmerge --help 2>&1 ';
					$merge_command = 'scripts/rrdmerge "'.$merge_source.'" "'.$merge_destination.'" "'.$merge_destination.'" 2>&1 ';
					/* Executing Merge Command */
					exec($merge_command, $merge_output);
					//$html .= 'merge_output '.$merge_output.'<br />';
					
					/* Outputting Results */
					if (sizeof($merge_output) == 0) {
					//if ($merge_output == '') {
						$html .= 'OK<br />';
						} /* End if ($merge_output == '') { */
					else {
						foreach ($merge_output as $output_line) {
							$html .= $output_line.'<br />';
							} /* End foreach ($merge_output as $output_line) { */
						//$merge_output = implode('\n',$merge_output);
						//$html .= $merge_output.'<br />';
						} /* End else { */
					break; /* End case 'specific': case 'folder': case 'structure': */
				} /* End switch ($performancedatatool_action_merge_type_selected) { */
			break; /* End case 'merge': */
		} /* End switch ($performancedatatool_action) { */
	

	return $html; 
	} /* End function performancedatatool_actions() { */


