<?php  
// performance_data_tool_display_contents COMPONENT
//
// Copyright 2016-05-05 Troy Lea aka Box293
// 

require_once(dirname(__FILE__).'/../../common.inc.php');
//require_once(dirname(__FILE__).'/../componenthelper.inc.php');
//require_once(dirname(__FILE__).'/../pnp/pnpproxy.inc.php');
//require_once(dirname(__FILE__).'/../pnp/pnp.inc.php');

// initialization stuff
pre_init();
// start session
init_session();
// grab GET or POST variables 
grab_request_vars();
// check prereqs
check_prereqs();
// check authentication
check_authentication(false);

/* Create the HTML Header */
?>
<!DOCTYPE html>
	<html>
	<head>
	<title>Nagios XI - Performance Data Tool</title>
	<meta http-equiv='Content-Type' content='text/html; charset=UTF-8' />
	<?php
	do_page_head_links();
	?>
	<link href="../performancedatatool/performance_data_tool.css" rel="stylesheet" type="text/css" />
	<script type="text/javascript" src="../performancedatatool/performance_data_tool.js"></script>
	<script type="text/javascript" src="../../js/jquery/jquery.tablesorter.js"></script>
	</head>
<?php

/* This adds padding for XI 5.x onwards */
if (get_product_release() > 416) {
	?>
		<body style="padding: 5px 5px 5px 5px;">
	<?php
	} /* End if (get_product_release() > 416) { */
else {
	?>
		<body>
	<?php
	} /* End else { */
	
/* Build the HTML content */
$html = performancedatatool_display_contents();
print $html; 



/* FUNCTIONS */

function performancedatatool_display_contents() {
	/* Get the foldername passed to us */
	$performancedatatool_foldername = urldecode(grab_request_var('foldername',false));
	//print_r("performancedatatool_foldername: $performancedatatool_foldername<br/>");

	/* Get the folderlocation passed to us */
	$performancedatatool_folderlocation = urldecode(grab_request_var('folderlocation',false));
	//print_r("performancedatatool_folderlocation: $performancedatatool_folderlocation<br/>");

	/* Get the foldertype passed to us */
	$performancedatatool_foldertype = grab_request_var('foldertype',false);
	//print_r("performancedatatool_foldertype: $performancedatatool_foldertype<br/>");

	/* Get the filename passed to us */
	$performancedatatool_filename = urldecode(grab_request_var('filename',false));
	//print_r("performancedatatool_filename: $performancedatatool_filename<br/>");

	/* Define performancedatatool_folder_file */
	switch ($performancedatatool_foldertype) {
		case 'type0':
		case 'type1':
			$performancedatatool_folder_file = $performancedatatool_folderlocation . '/' . $performancedatatool_foldername . '/' . $performancedatatool_filename;
			break; /* End case 'type0': and case 'type1': */
		
		case 'type2':
			$performancedatatool_folder_file = $performancedatatool_folderlocation . '/' . $performancedatatool_filename;
			break; /* End case 'type2': */

		case 'type3':
			$performancedatatool_folder_file = $performancedatatool_filename;
			break; /* End case 'type3': */
		} /* End switch ($performancedatatool_foldertype) { */
	
	/* Determine the file extension */
	$performancedatatool_folder_file_extension = pathinfo($performancedatatool_folder_file, PATHINFO_EXTENSION);
	
	$html = '';
	
	
	switch ($performancedatatool_folder_file_extension) {
		case 'xml':
			/* Displaying the name of the file at the top */
			$html .= '<h2>'.realpath($performancedatatool_folder_file).'</h2>';
			
			/* Call the function to display the XML file contents */
			$html .= display_xml($performancedatatool_folder_file);
			break; /* End case 'xml': */

		case 'rrd':
			/* Defining XML filename, we are getting an rrd filename passed to us in this function */
			$performancedatatool_folder_file_xml = substr($performancedatatool_folder_file, 0, -3);
			$performancedatatool_folder_file_xml .= 'xml';
			
			/* This is the menu bar */
			$html .= '
				<div id="menubar2">
					<input type="button" class="performancedatatool-menuheading1" id="id-performancedatatool-graph" onclick="performancedatatool_ToggleMenu(\'performancedatatool-graph\')" value="RRD Graph">
					<input type="button" class="performancedatatool-menuheading2" id="id-performancedatatool-rawdata" onclick="performancedatatool_ToggleMenu(\'performancedatatool-rawdata\')" value="RRD Raw Data">
				';
			/* Only show the XML tab if the user is an admin */
			if(is_admin() == true) {
				$html .= '
					<input type="button" class="performancedatatool-menuheading1" id="id-performancedatatool-xml" onclick="performancedatatool_ToggleMenu(\'performancedatatool-xml\')" value="XML Data">
				</div>
				';
				} /* End if(is_admin() == true) { */
			
			/* This is the RRD Graph tab */
			
			$performancedatatool_hostname = $performancedatatool_foldername;
			$performancedatatool_servicename = $performancedatatool_filename;
			//$rrd_graph = pnp_display_chart($hostname=$performancedatatool_hostname,$servicename=$performancedatatool_servicename,$source=1,$view=PNP_VIEW_DEFAULT,$start="",$end="",$dashit=false);
			
			//pnp_display_chart($hostname='localhost',$servicename='HTTP',$source=1,$view=PNP_VIEW_DEFAULT,$start="",$end="",$dashit=false);
	
			
			
			
			
			
			$html .= '
				<div id="performancedatatool-graph" class="performancedatatool-togglediv" style="display:none">
					<!--Displaying the name of the file at the top-->
					<h2>'.realpath($performancedatatool_folder_file).'</h2>
					<h3>Feature not yet implemented, coming soon!</h3>
					<br />
					<br />
					
					
					
					
				</div>
				';
			
			/* This is the RRD Raw Data tab */
			$html .= '<div id="performancedatatool-rawdata" class="performancedatatool-togglediv">';
			/* Displaying the name of the file at the top */
			$html .= '<h2>'.realpath($performancedatatool_folder_file).'</h2>';

			/* Create the menu bar for the different tables */
			$html .= '
				<div id="menubar3">
					<input type="button" class="performancedatatool-menuheading-sub2" id="id-performancedatatool-rawdata-average" onclick="performancedatatool_ToggleMenuSub(\'performancedatatool-rawdata-average\')" value="Average">
					<input type="button" class="performancedatatool-menuheading-sub1" id="id-performancedatatool-rawdata-min" onclick="performancedatatool_ToggleMenuSub(\'performancedatatool-rawdata-min\')" value="Min">
					<input type="button" class="performancedatatool-menuheading-sub1" id="id-performancedatatool-rawdata-max" onclick="performancedatatool_ToggleMenuSub(\'performancedatatool-rawdata-max\')" value="Max">
				</div>
				';

			/* Call the function to display the RRD contents as a table - AVERAGE */
			$html .= '
				<div id="performancedatatool-rawdata-average" class="performancedatatool-togglediv-sub">
					<div class="performancedatatool-spacer5"> </div>
					<div id="menubar-average">
						<input type="button" class="performancedatatool-menuheading-sub-average2" id="id-performancedatatool-rawdata-average-1d" onclick="performancedatatool_ToggleMenuSubSub(\'performancedatatool-rawdata-average-1d,average\')" value="D">
						<input type="button" class="performancedatatool-menuheading-sub-average1" id="id-performancedatatool-rawdata-average-3d" onclick="performancedatatool_ToggleMenuSubSub(\'performancedatatool-rawdata-average-3d,average\')" value="3 D">
						<input type="button" class="performancedatatool-menuheading-sub-average1" id="id-performancedatatool-rawdata-average-1w" onclick="performancedatatool_ToggleMenuSubSub(\'performancedatatool-rawdata-average-1w,average\')" value="W">
						<input type="button" class="performancedatatool-menuheading-sub-average1" id="id-performancedatatool-rawdata-average-2w" onclick="performancedatatool_ToggleMenuSubSub(\'performancedatatool-rawdata-average-2w,average\')" value="2 W">
						<input type="button" class="performancedatatool-menuheading-sub-average1" id="id-performancedatatool-rawdata-average-1m" onclick="performancedatatool_ToggleMenuSubSub(\'performancedatatool-rawdata-average-1m,average\')" value="M">
						<input type="button" class="performancedatatool-menuheading-sub-average1" id="id-performancedatatool-rawdata-average-2m" onclick="performancedatatool_ToggleMenuSubSub(\'performancedatatool-rawdata-average-2m,average\')" value="2 M">
						<input type="button" class="performancedatatool-menuheading-sub-average1" id="id-performancedatatool-rawdata-average-6m" onclick="performancedatatool_ToggleMenuSubSub(\'performancedatatool-rawdata-average-6m,average\')" value="6 M">
						<input type="button" class="performancedatatool-menuheading-sub-average1" id="id-performancedatatool-rawdata-average-1y" onclick="performancedatatool_ToggleMenuSubSub(\'performancedatatool-rawdata-average-1y,average\')" value="Y">
						<input type="button" class="performancedatatool-menuheading-sub-average1" id="id-performancedatatool-rawdata-average-2y" onclick="performancedatatool_ToggleMenuSubSub(\'performancedatatool-rawdata-average-2y,average\')" value="2 Y">
						<input type="button" class="performancedatatool-menuheading-sub-average1" id="id-performancedatatool-rawdata-average-4y" onclick="performancedatatool_ToggleMenuSubSub(\'performancedatatool-rawdata-average-4y,average\')" value="4 Y">
					</div>

					<div id="performancedatatool-rawdata-average-1d" class="performancedatatool-togglediv-sub-average">
						'.rrd_table('AVERAGE', '-s -1d -e now', $performancedatatool_folder_file, $performancedatatool_folder_file_xml).'
					</div>

					<div id="performancedatatool-rawdata-average-3d" class="performancedatatool-togglediv-sub-average" style="display:none">
						'.rrd_table('AVERAGE', '-s -3d -e now', $performancedatatool_folder_file, $performancedatatool_folder_file_xml).'
					</div>

					<div id="performancedatatool-rawdata-average-1w" class="performancedatatool-togglediv-sub-average" style="display:none">
						'.rrd_table('AVERAGE', '-s -1w -e now', $performancedatatool_folder_file, $performancedatatool_folder_file_xml).'
					</div>

					<div id="performancedatatool-rawdata-average-2w" class="performancedatatool-togglediv-sub-average" style="display:none">
						'.rrd_table('AVERAGE', '-s -2w -e now', $performancedatatool_folder_file, $performancedatatool_folder_file_xml).'
					</div>

					<div id="performancedatatool-rawdata-average-1m" class="performancedatatool-togglediv-sub-average" style="display:none">
						'.rrd_table('AVERAGE', '-s -1m -e now', $performancedatatool_folder_file, $performancedatatool_folder_file_xml).'
					</div>

					<div id="performancedatatool-rawdata-average-2m" class="performancedatatool-togglediv-sub-average" style="display:none">
						'.rrd_table('AVERAGE', '-s -2m -e now', $performancedatatool_folder_file, $performancedatatool_folder_file_xml).'
					</div>

					<div id="performancedatatool-rawdata-average-6m" class="performancedatatool-togglediv-sub-average" style="display:none">
						'.rrd_table('AVERAGE', '-s -6m -e now', $performancedatatool_folder_file, $performancedatatool_folder_file_xml).'
					</div>

					<div id="performancedatatool-rawdata-average-1y" class="performancedatatool-togglediv-sub-average" style="display:none">
						'.rrd_table('AVERAGE', '-s -1y -e now', $performancedatatool_folder_file, $performancedatatool_folder_file_xml).'
					</div>

					<div id="performancedatatool-rawdata-average-2y" class="performancedatatool-togglediv-sub-average" style="display:none">
						'.rrd_table('AVERAGE', '-s -2y -e now', $performancedatatool_folder_file, $performancedatatool_folder_file_xml).'
					</div>

					<div id="performancedatatool-rawdata-average-4y" class="performancedatatool-togglediv-sub-average" style="display:none">
						'.rrd_table('AVERAGE', '-s -4y -e now', $performancedatatool_folder_file, $performancedatatool_folder_file_xml).'
					</div>
				</div>
				';

			/* Call the function to display the RRD contents as a table - MIN */
			$html .= '
				<div id="performancedatatool-rawdata-min" class="performancedatatool-togglediv-sub" style="display:none">
					<div class="performancedatatool-spacer5"> </div>
					<div id="menubar-min">
						<input type="button" class="performancedatatool-menuheading-sub-min2" id="id-performancedatatool-rawdata-min-1d" onclick="performancedatatool_ToggleMenuSubSub(\'performancedatatool-rawdata-min-1d,min\')" value="D">
						<input type="button" class="performancedatatool-menuheading-sub-min1" id="id-performancedatatool-rawdata-min-3d" onclick="performancedatatool_ToggleMenuSubSub(\'performancedatatool-rawdata-min-3d,min\')" value="3 D">
						<input type="button" class="performancedatatool-menuheading-sub-min1" id="id-performancedatatool-rawdata-min-1w" onclick="performancedatatool_ToggleMenuSubSub(\'performancedatatool-rawdata-min-1w,min\')" value="W">
						<input type="button" class="performancedatatool-menuheading-sub-min1" id="id-performancedatatool-rawdata-min-2w" onclick="performancedatatool_ToggleMenuSubSub(\'performancedatatool-rawdata-min-2w,min\')" value="2 W">
						<input type="button" class="performancedatatool-menuheading-sub-min1" id="id-performancedatatool-rawdata-min-1m" onclick="performancedatatool_ToggleMenuSubSub(\'performancedatatool-rawdata-min-1m,min\')" value="M">
						<input type="button" class="performancedatatool-menuheading-sub-min1" id="id-performancedatatool-rawdata-min-2m" onclick="performancedatatool_ToggleMenuSubSub(\'performancedatatool-rawdata-min-2m,min\')" value="2 M">
						<input type="button" class="performancedatatool-menuheading-sub-min1" id="id-performancedatatool-rawdata-min-6m" onclick="performancedatatool_ToggleMenuSubSub(\'performancedatatool-rawdata-min-6m,min\')" value="6 M">
						<input type="button" class="performancedatatool-menuheading-sub-min1" id="id-performancedatatool-rawdata-min-1y" onclick="performancedatatool_ToggleMenuSubSub(\'performancedatatool-rawdata-min-1y,min\')" value="Y">
						<input type="button" class="performancedatatool-menuheading-sub-min1" id="id-performancedatatool-rawdata-min-2y" onclick="performancedatatool_ToggleMenuSubSub(\'performancedatatool-rawdata-min-2y,min\')" value="2 Y">
						<input type="button" class="performancedatatool-menuheading-sub-min1" id="id-performancedatatool-rawdata-min-4y" onclick="performancedatatool_ToggleMenuSubSub(\'performancedatatool-rawdata-min-4y,min\')" value="4 Y">
					</div>

					<div id="performancedatatool-rawdata-min-1d" class="performancedatatool-togglediv-sub-min">
						'.rrd_table('MIN', '-s -1d -e now', $performancedatatool_folder_file, $performancedatatool_folder_file_xml).'
					</div>

					<div id="performancedatatool-rawdata-min-3d" class="performancedatatool-togglediv-sub-min" style="display:none">
						'.rrd_table('MIN', '-s -3d -e now', $performancedatatool_folder_file, $performancedatatool_folder_file_xml).'
					</div>

					<div id="performancedatatool-rawdata-min-1w" class="performancedatatool-togglediv-sub-min" style="display:none">
						'.rrd_table('MIN', '-s -1w -e now', $performancedatatool_folder_file, $performancedatatool_folder_file_xml).'
					</div>

					<div id="performancedatatool-rawdata-min-2w" class="performancedatatool-togglediv-sub-min" style="display:none">
						'.rrd_table('MIN', '-s -2w -e now', $performancedatatool_folder_file, $performancedatatool_folder_file_xml).'
					</div>

					<div id="performancedatatool-rawdata-min-1m" class="performancedatatool-togglediv-sub-min" style="display:none">
						'.rrd_table('MIN', '-s -1m -e now', $performancedatatool_folder_file, $performancedatatool_folder_file_xml).'
					</div>

					<div id="performancedatatool-rawdata-min-2m" class="performancedatatool-togglediv-sub-min" style="display:none">
						'.rrd_table('MIN', '-s -2m -e now', $performancedatatool_folder_file, $performancedatatool_folder_file_xml).'
					</div>

					<div id="performancedatatool-rawdata-min-6m" class="performancedatatool-togglediv-sub-min" style="display:none">
						'.rrd_table('MIN', '-s -6m -e now', $performancedatatool_folder_file, $performancedatatool_folder_file_xml).'
					</div>

					<div id="performancedatatool-rawdata-min-1y" class="performancedatatool-togglediv-sub-min" style="display:none">
						'.rrd_table('MIN', '-s -1y -e now', $performancedatatool_folder_file, $performancedatatool_folder_file_xml).'
					</div>

					<div id="performancedatatool-rawdata-min-2y" class="performancedatatool-togglediv-sub-min" style="display:none">
						'.rrd_table('MIN', '-s -2y -e now', $performancedatatool_folder_file, $performancedatatool_folder_file_xml).'
					</div>

					<div id="performancedatatool-rawdata-min-4y" class="performancedatatool-togglediv-sub-min" style="display:none">
						'.rrd_table('MIN', '-s -4y -e now', $performancedatatool_folder_file, $performancedatatool_folder_file_xml).'
					</div>
				</div>
				';

			/* Call the function to display the RRD contents as a table - MAX */
			$html .= '
				<div id="performancedatatool-rawdata-max" class="performancedatatool-togglediv-sub" style="display:none">
					<div class="performancedatatool-spacer5"> </div>
					<div id="menubar-max">
						<input type="button" class="performancedatatool-menuheading-sub-max2" id="id-performancedatatool-rawdata-max-1d" onclick="performancedatatool_ToggleMenuSubSub(\'performancedatatool-rawdata-max-1d,max\')" value="D">
						<input type="button" class="performancedatatool-menuheading-sub-max1" id="id-performancedatatool-rawdata-max-3d" onclick="performancedatatool_ToggleMenuSubSub(\'performancedatatool-rawdata-max-3d,max\')" value="3 D">
						<input type="button" class="performancedatatool-menuheading-sub-max1" id="id-performancedatatool-rawdata-max-1w" onclick="performancedatatool_ToggleMenuSubSub(\'performancedatatool-rawdata-max-1w,max\')" value="W">
						<input type="button" class="performancedatatool-menuheading-sub-max1" id="id-performancedatatool-rawdata-max-2w" onclick="performancedatatool_ToggleMenuSubSub(\'performancedatatool-rawdata-max-2w,max\')" value="2 W">
						<input type="button" class="performancedatatool-menuheading-sub-max1" id="id-performancedatatool-rawdata-max-1m" onclick="performancedatatool_ToggleMenuSubSub(\'performancedatatool-rawdata-max-1m,max\')" value="M">
						<input type="button" class="performancedatatool-menuheading-sub-max1" id="id-performancedatatool-rawdata-max-2m" onclick="performancedatatool_ToggleMenuSubSub(\'performancedatatool-rawdata-max-2m,max\')" value="2 M">
						<input type="button" class="performancedatatool-menuheading-sub-max1" id="id-performancedatatool-rawdata-max-6m" onclick="performancedatatool_ToggleMenuSubSub(\'performancedatatool-rawdata-max-6m,max\')" value="6 M">
						<input type="button" class="performancedatatool-menuheading-sub-max1" id="id-performancedatatool-rawdata-max-1y" onclick="performancedatatool_ToggleMenuSubSub(\'performancedatatool-rawdata-max-1y,max\')" value="Y">
						<input type="button" class="performancedatatool-menuheading-sub-max1" id="id-performancedatatool-rawdata-max-2y" onclick="performancedatatool_ToggleMenuSubSub(\'performancedatatool-rawdata-max-2y,max\')" value="2 Y">
						<input type="button" class="performancedatatool-menuheading-sub-max1" id="id-performancedatatool-rawdata-max-4y" onclick="performancedatatool_ToggleMenuSubSub(\'performancedatatool-rawdata-max-4y,max\')" value="4 Y">
					</div>

					<div id="performancedatatool-rawdata-max-1d" class="performancedatatool-togglediv-sub-max">
						'.rrd_table('MAX', '-s -1d -e now', $performancedatatool_folder_file, $performancedatatool_folder_file_xml).'
					</div>

					<div id="performancedatatool-rawdata-max-3d" class="performancedatatool-togglediv-sub-max" style="display:none">
						'.rrd_table('MAX', '-s -3d -e now', $performancedatatool_folder_file, $performancedatatool_folder_file_xml).'
					</div>

					<div id="performancedatatool-rawdata-max-1w" class="performancedatatool-togglediv-sub-max" style="display:none">
						'.rrd_table('MAX', '-s -1w -e now', $performancedatatool_folder_file, $performancedatatool_folder_file_xml).'
					</div>

					<div id="performancedatatool-rawdata-max-2w" class="performancedatatool-togglediv-sub-max" style="display:none">
						'.rrd_table('MAX', '-s -2w -e now', $performancedatatool_folder_file, $performancedatatool_folder_file_xml).'
					</div>

					<div id="performancedatatool-rawdata-max-1m" class="performancedatatool-togglediv-sub-max" style="display:none">
						'.rrd_table('MAX', '-s -1m -e now', $performancedatatool_folder_file, $performancedatatool_folder_file_xml).'
					</div>

					<div id="performancedatatool-rawdata-max-2m" class="performancedatatool-togglediv-sub-max" style="display:none">
						'.rrd_table('MAX', '-s -2m -e now', $performancedatatool_folder_file, $performancedatatool_folder_file_xml).'
					</div>

					<div id="performancedatatool-rawdata-max-6m" class="performancedatatool-togglediv-sub-max" style="display:none">
						'.rrd_table('MAX', '-s -6m -e now', $performancedatatool_folder_file, $performancedatatool_folder_file_xml).'
					</div>

					<div id="performancedatatool-rawdata-max-1y" class="performancedatatool-togglediv-sub-max" style="display:none">
						'.rrd_table('MAX', '-s -1y -e now', $performancedatatool_folder_file, $performancedatatool_folder_file_xml).'
					</div>

					<div id="performancedatatool-rawdata-max-2y" class="performancedatatool-togglediv-sub-max" style="display:none">
						'.rrd_table('MAX', '-s -2y -e now', $performancedatatool_folder_file, $performancedatatool_folder_file_xml).'
					</div>

					<div id="performancedatatool-rawdata-max-4y" class="performancedatatool-togglediv-sub-max" style="display:none">
						'.rrd_table('MAX', '-s -4y -e now', $performancedatatool_folder_file, $performancedatatool_folder_file_xml).'
					</div>
				</div>
				';

			$html .= '</div>';
			

			/* This is the XML Data tab */
			/* Only show the following if the user is an admin */
			if(is_admin() == true) {
				$html .= '<div id="performancedatatool-xml" class="performancedatatool-togglediv" style="display:none">';
				/* Only show the following if the XML file exists */
				if (file_exists($performancedatatool_folder_file_xml)) {
					// Displaying the name of the file at the top
					$html .= '<h2>'.realpath($performancedatatool_folder_file_xml).'</h2>';
					/* Call the function to display the XML contents */
					$html .= display_xml($performancedatatool_folder_file_xml);
					} /* End if (file_exists($performancedatatool_folder_file_xml)) { */
				else {
					// Could not find the XML file
					$html .= '<h2>ERROR: '.$performancedatatool_folder_file_xml.' NOT found</h2>';
					} /* End else { */
				$html .= '</div>';
				} /* End if(is_admin() == true) { */
			break; /* End case 'rrd': */
		
		} /* End switch $performancedatatool_folder_file_extension { */
	
	$html .= '</body>';
	$html .= '</html>';
	
	return $html; 
	} /* End function performancedatatool_display_contents() { */

	
	
function display_xml($performancedatatool_folder_file) {
	$xml = simplexml_load_file($performancedatatool_folder_file);
	$blue = 'performancedatatool-blue';
	$green = 'performancedatatool-green';
	$black = 'performancedatatool-black';
	$padding_child1 = 'performancedatatool-padding-child1';
	$padding_child2 = 'performancedatatool-padding-child2';
	$html_xml = '<span class="'.$blue.'">' . htmlspecialchars('<') . '</span>' . '<span class="'.$green.'">' . $xml->getName() . '</span>' . '<span class="'.$blue.'">' . htmlspecialchars('>') . '</span>' . '<br>';
	foreach ($xml->children() as $child1) {
		switch ($child1->getName()) {
			case 'DATASOURCE':
			case 'RRD':
			case 'XML':
				$html_xml .= '<span class="'.$padding_child1.'">' . '<span class="'.$blue.'">' . htmlspecialchars('<') . '</span>' . '<span class="'.$green.'">' . $child1->getName() . '</span>' . '<span class="'.$blue.'">' . htmlspecialchars('>') . '</span>' . '</span>' . '<br>';
				foreach ($child1->children() as $child2) {
					$html_xml .= '<span class="'.$padding_child2.'">' . '<span class="'.$blue.'">' . htmlspecialchars('<') . '</span>' . '<span class="'.$green.'">' . $child2->getName() . '</span>' . '<span class="'.$blue.'">' . htmlspecialchars('>') . '</span>' . '<span class="'.$black.'">' . $child2 . '</span>' . '<span class="'.$blue.'">' . htmlspecialchars('</') . '</span>' . '<span class="'.$green.'">' . $child2->getName() . '</span>' . '<span class="'.$blue.'">' . htmlspecialchars('>') . '</span>' . '</span>' . '<br>';
					}
				$html_xml .= '<span class="'.$padding_child1.'">' . '<span class="'.$blue.'">' . htmlspecialchars('</') . '</span>' . '<span class="'.$green.'">' . $child1->getName() . '</span>' . '<span class="'.$blue.'">' . htmlspecialchars('>') . '</span>' . '</span>' . '<br>';
				break;
			
			default:
				$html_xml .= '<span class="'.$padding_child1.'">' . '<span class="'.$blue.'">' . htmlspecialchars('<') . '</span>' . '<span class="'.$green.'">' . $child1->getName() . '</span>' . '<span class="'.$blue.'">' . htmlspecialchars('>') . '</span>' . '<span class="'.$black.'">' . $child1 . '</span>' . '<span class="'.$blue.'">' . htmlspecialchars('</') . '</span>' . '<span class="'.$green.'">' . $child1->getName() . '</span>' . '<span class="'.$blue.'">' . htmlspecialchars('>') . '</span>' . '</span>' . '<br>';
				break;
				
			} /* End switch ($child1) { */
		} /* End foreach ($xml->children() as $child1) { */
	$html_xml .= '<span class="'.$blue.'">' . htmlspecialchars('</') . '</span>' . '<span class="'.$green.'">' . $xml->getName() . '</span>' . '<span class="'.$blue.'">' . htmlspecialchars('>') . '</span>' . '<br>';
	return $html_xml;
	} /* End function display_xml */
	
	
	
function rrd_table($cf, $period, $performancedatatool_folder_file, $performancedatatool_folder_file_xml) {
	// Using FETCH
	$rrd_command = '/usr/bin/rrdtool fetch "' . $performancedatatool_folder_file . '" ' . $cf . ' ' . $period;
	exec($rrd_command, $rrd_contents, $rrd_exitcode);
	//print_r($rrd_command . '<br><br>');
	//print_r($rrd_contents . '<br><br>');
	//print_r($rrd_exitcode . '<br><br>');
	
	// Determining it rrdtool returned an exit code
	if ($rrd_exitcode != 1) {
		
		/* Define ds_item_counter */
		$ds_item_counter = 0;
			
		/* Define ds_array array */
		$ds_array = '';
		
		/* Check to see if the XML file exists */
		if (file_exists($performancedatatool_folder_file_xml)) {
			//print_r('<br>XML file exists<br>');
			// The following is obtaining the name of each Datasource to use as values in the table header
			$xml = simplexml_load_file($performancedatatool_folder_file_xml);
			foreach ($xml->children() as $child1) {
				$ds_counter_trigger = 0;
				switch ($child1->getName()) {
					case 'DATASOURCE':
						foreach ($child1->children() as $child2) {
							$xml_tag = $child2->getName();
							switch ($xml_tag) {
								case 'DS':	
									/* Now add the item to the ds_array array */
									$ds_array[$ds_item_counter]['dsNumber'] = $child2;
									$ds_counter_trigger++;
									break; /* End case 'DS': */
								case 'NAME':	
									/* Now add the item to the ds_array array */
									$ds_array[$ds_item_counter]['dsName'] = $child2;
									$ds_counter_trigger++;
									break; /* End case 'NAME': */
								case 'UNIT':	
									/* Now add the item to the ds_array array */
									$ds_array[$ds_item_counter]['dsUnit'] = $child2;
									$ds_counter_trigger++;
									break; /* End case 'UNIT': */
								} /* End switch ($xml_tag) { */
							} /* End foreach ($child1->children() as $child2) { */
						break; /* End case 'DATASOURCE': */
					} /* End switch ($child1) { */
				if ($ds_counter_trigger > 0) {
					$ds_item_counter++;
					} /* End if ($ds_counter_trigger > 0) { */
				} /* End foreach ($xml->children() as $child1) { */
			} /* End if (file_exists($performancedatatool_folder_file_xml)) { */
		else {
			/* Because an XML file does not exist we will query the RRD file for some info and create a ds_array */
			//print_r('<br>XML file does NOT exists<br>');
			$rrd_info_command = '/usr/bin/rrdtool info "' . $performancedatatool_folder_file . '"';
			exec($rrd_info_command, $rrd_info_contents, $rrd_info_exitcode);
			
			foreach ($rrd_info_contents as $line) {
				$ds_check = strpos($line, 'ds[');
				if ($ds_check !== false) {
					preg_match_all("^\[(.*?)\]^", $line, $ds_match, PREG_PATTERN_ORDER);
					//print_r('<br>--------<br>');
					//print_r('~' . $ds_match[1][0] . '~');	
					//print_r('<br>--------<br>');
					if ($ds_match[1][0] > $ds_item_counter) {
						$ds_array[$ds_item_counter]['dsNumber'] = 'ds' . $ds_match[1][0];
						$ds_array[$ds_item_counter]['dsName'] = '';
						$ds_array[$ds_item_counter]['dsUnit'] = '';
						$ds_item_counter++;
						} /* End if ($ds_match[1][0] > $ds_item_counter) { */
					} /* End if ($ds_check !== false) { */
				} /* End foreach ($rrd_info_contents as $line) { */
			} /* End else { */
		
		$table_id = rand();
		$html_rrd_table = '
			<div>
				<div class="performancedatatool-spacer8"> </div>
				 <pre><span class="performancedatatool-font-weight-bold">Command:</span> '.$rrd_command.'</pre>
				<table id="'.$table_id.'" class="tablesorter">
				<thead><tr><th>Date / Time</th>
			';
		
		// Adding each Datasource value as header(s) for the table
		for($d=0; $d<$ds_item_counter; $d++) {
			$html_rrd_table .= '<th>';
			$html_rrd_table .= $ds_array[$d]['dsNumber'];
			// Checking to see if the Name is not a blank value
			if ($ds_array[$d]['dsName'] != '') {
				$html_rrd_table .= ' - ';
				$html_rrd_table .= $ds_array[$d]['dsName'];
				} /* End if ($ds_array[$d]['dsName'] != '') { */
			// Checking to see if the Unit is not a blank value
			if ($ds_array[$d]['dsUnit'] != '') {
				$html_rrd_table .= ' (';
				// Formatting some known units
				switch ($ds_array[$d]['dsUnit']) {
					case '%%':
						$html_rrd_table .= '%';
						break; /* End case '%%': */
					
					default:
						$html_rrd_table .= $ds_array[$d]['dsUnit'];
						break; /* End case default: */
					} /* End switch ($ds_array[$d]['dsUnit']) { */
				$html_rrd_table .= ')';
				} /* End if ($ds_array[$d]['dsUnit'] != '') { */
			$html_rrd_table .= '</th>';
			} /* End foreach($ds_array as $ds_value) { */
		
		// Finishing the table header
		$html_rrd_table .= '
			</tr></thead>
			';
		// Now add each line of data from the .rrd file to the table	
		foreach ($rrd_contents as $line) {
			//print_r('<br>--------<br>');
			//print_r('~' . $line . '~');	
			//print_r('<br>--------<br>');
			if ((strpos($line, ' 1') === false)) {
				if ($line != '') {
					if ((strpos($line, '-nan') === false)) {
						$line_exploded = explode(':', trim($line));
						if ($line_exploded[1] != '-nan') {
							$html_rrd_table .= '<tr><td>';
							//print_r('----<br>');
							$dt = date('Y-m-d H:i:s', $line_exploded[0]);
							$html_rrd_table .= $dt . '</td>';
							//print_r('~' . $dt . '~<br>');
							$values = explode(' ', trim($line_exploded[1]));
							for($v=0;$v<count($values);$v++) {
								$html_rrd_table .= '<td>';
								$current_ds = $v + 1;
								$current_value = $values[$v];
								//handle rrd exponent multiplier 
								$parts = explode('e',$current_value); 
								$flt = $parts[0]; //the float
								$power = $parts[1];  //the multiplier ie -02 or +02 
								$mult = pow(10,$power); //get the actual multiplier 
								$current_value_real = $flt * $mult; //get the real number 	
								$html_rrd_table .= $current_value_real . '</td>';
								//print_r('DS' . $current_ds . ': ~' . $values[$v] . '~<br>');
								} /* End for($v=0;$v<count($values);$v++) { */
							$html_rrd_table .= '</tr>';
							} /* End if ($line_exploded[1] != '-nan') { */
						} /* End if ((strpos($line, '-nan') === false)) { */
					} /* End if ($line != '') { */
				} /* End if ((strpos($line, ' 1') === false)) { */
			} /* End foreach ($rrd_contents as $line) { */
		$html_rrd_table .= '
				</table>
			</div>
			<script type="text/javascript">
				performancedatatool_ToolTipShowContent();
				performancedatatool_SortTable("'.$table_id.',DisplayContent");
			</script>
			';
		} /* End if ($rrd_exitcode != 1) { */
	else {
		// rrdtool returned an error exit code
		$html_rrd_table = '
			<div>
				Oooops!!! It appears that rrdtool returned an error when trying to query '.realpath($performancedatatool_folder_file).'.
				<br>
				<br>
				A reason for this is that the RRD file was created on a different architecture. For example the rrd file was created on an x86 computer and now it is on an x64 computer.
			</div>
			';
		} /* End else { */
	return $html_rrd_table;
	} /* End function rrd_table ($performancedatatool_folder_file) { */
	
