<?php  
// performance_data_tool_draw_table COMPONENT
//
// Copyright 2016-05-05 Troy Lea aka Box293
// 

require_once(dirname(__FILE__).'/../../common.inc.php');

// initialization stuff
pre_init();
// start session
init_session();
// grab GET or POST variables 
grab_request_vars();
// check prereqs
check_prereqs();
// check authentication
check_authentication(false);


/* Get the select_supplied_name passed to us */
$performancedatatool_select_supplied_name = urldecode(grab_request_var('select_supplied_name',false));


/* Build the HTML content */
if ($performancedatatool_select_supplied_name == 'merge_list') {
	$html = performancedatatool_draw_merge_list();
	} /* End if ($performancedatatool_select_supplied_name == 'merge_list') { */
else {
	$html = performancedatatool_draw_table();
	} /* End else { */
print $html; 



/* FUNCTIONS */

function performancedatatool_draw_merge_list() {
	/* Get the merge_list_array passed to us */
	$performancedatatool_merge_list_array = json_decode(urldecode(grab_request_var('merge_list_array',false)));
	
	/* Check to see if the merge list array is empty */
	if (sizeof($performancedatatool_merge_list_array) == 0) {
		$html = '<h3><i>There are currently no items in the merge list!</i></h3>';
		} /* End if ($performancedatatool_merge_list_array == '') { */
	else {
		/* Otherwise draw the Merge List */
		$performancedatatool_merge_list_total_items = count($performancedatatool_merge_list_array);
		
		$html = '<h2>Merge List</h2>';
		
		if ($performancedatatool_merge_list_total_items > 1) {
			$html .= 'There are '.$performancedatatool_merge_list_total_items.' items in the merge list';
			}
		else {
			$html .= 'There is '.$performancedatatool_merge_list_total_items.' item in the merge list';
			}
		
		$html .= '<table id="merge-list-table" class="tablesorter">';
		$html .= '<thead><tr><th class="performancedatatool-width20"></th><th>Source</th><th>Destination</th></tr></thead>';
		/* Loop through the array  */
		foreach ($performancedatatool_merge_list_array as $nested_array) {
			$html .= '<tr>';
			$html .= '<td><input type="checkbox" name="'.urlencode(json_encode($nested_array)).'" id="'.urlencode(json_encode($nested_array)).'" class="performancedatatool-checkbox-merge-list" value="'.urlencode(json_encode($nested_array)).'"></td><td>'.urldecode($nested_array[0]).'</td><td>'.urldecode($nested_array[1]).'</td>';
			$html .= '</tr>';
			} /* End foreach ($performancedatatool_merge_list_array as $nested_array) { */
		
		$html .= '
			</table>
			<input type="hidden" name="performancedatatool_merge_list_array" id="id_performancedatatool_merge_list_array" value="'.urlencode(json_encode($performancedatatool_merge_list_array)).'">
			
			<script type="text/javascript">
			$(document).ready(function() {
				performancedatatool_ToolTipShowContent();
				performancedatatool_SortTable("merge-list-table,merge-list");
				}); 
			</script>
			';
		} /* End else { */
	return $html; 
	} /* End function performancedatatool_draw_merge_list() { */

	
function performancedatatool_draw_table() {
	/* Get the folder_name passed to us */
	$performancedatatool_foldername = urldecode(grab_request_var('folder_name',false));
	/* Get the folder_location passed to us */
	$performancedatatool_folderlocation = urldecode(urldecode(grab_request_var('folder_location',false)));
	/* Get the folder_type passed to us */
	$performancedatatool_foldertype = grab_request_var('folder_type',false);
	/* Get the select_supplied_name passed to us */
	$performancedatatool_select_supplied_name = urldecode(grab_request_var('select_supplied_name',false));
	/* Get the dateFilter passed to us */
	$performancedatatool_date_filter = grab_request_var('dateFilter',false);
	/* Convert it to unix time */
	$performancedatatool_date_filter_selected = determine_date_filter_value($performancedatatool_date_filter);
	
	$table_id = 'PerformanceDataTable-' . $performancedatatool_select_supplied_name . '-' . $performancedatatool_foldername;
	$table_id = str_replace('.', '_', $table_id);
	$div_id = 'performancedatatool-div-' . $performancedatatool_select_supplied_name . '-' . $performancedatatool_foldername;
	$all_performance_files = get_all_performance_files($performancedatatool_foldername, $performancedatatool_folderlocation, $performancedatatool_foldertype, $performancedatatool_date_filter_selected);
	$html = '
		<div id="'.$div_id.'">
		<div class="performancedatatool-spacer10"> </div>
		';
	
	if ($all_performance_files == '') {
		$html .= '
			There are no files that match the date filter you selected OR there are no files in this folder!
			<div class="performancedatatool-spacer15"> </div>
			<input type="hidden" name="performancedatatool_files_'.$performancedatatool_select_supplied_name.'" id="id_performancedatatool_files_'.$performancedatatool_select_supplied_name.'" value="no">
			';
		} /* End if ($all_performance_files == '') { */
	else {
		/* Defining file_counter */
		GLOBAL $file_counter;
		$file_counter = 0;
		/* Draw the table */
		$table = draw_table_of_files($table_id, $performancedatatool_foldername, $performancedatatool_folderlocation, $performancedatatool_foldertype, $all_performance_files, $performancedatatool_select_supplied_name);
		$html .= '
			Number of files displayed: '.$file_counter.'
			<div class="performancedatatool-spacer5"> </div>
			<input type="hidden" name="performancedatatool_files_'.$performancedatatool_select_supplied_name.'" id="id_performancedatatool_files_'.$performancedatatool_select_supplied_name.'" value="yes">
			'.$table.'
			<script type="text/javascript">
				$(document).ready(function() {
					performancedatatool_ToolTipShowContent();
					performancedatatool_SortTable("'.$table_id.','.$performancedatatool_select_supplied_name.'");
					}); 
			</script>
			';
		} /* End else { */
	
	$html .= '
		</div> <!-- End performancedatatool-table-foldername -->
		';
	return $html; 
	}


function get_all_performance_files($performancedatatool_foldername, $performancedatatool_folderlocation, $performancedatatool_foldertype, $performancedatatool_date_filter_selected) {
	//print_r('performancedatatool_foldername: ' . $performancedatatool_foldername . '<br/>');
	//print_r('performancedatatool_folderlocation: ' . $performancedatatool_folderlocation . '<br/>');
	//print_r('performancedatatool_foldertype: ' . $performancedatatool_foldertype . '<br/>');
	
	switch ($performancedatatool_foldertype) {
		case 'type0':
		case 'type1':
			$perfdata_folder = $performancedatatool_folderlocation . '/' . $performancedatatool_foldername;

			/* Get all items in the perfdata_folder */
			$perfdata_folder_contents = scandir($perfdata_folder);
			break; /* End case 'type0': and case 'type1': */
		
		case 'type2':
			$perfdata_folder = $performancedatatool_folderlocation;
			$perfdata_folder_contents = scandir($perfdata_folder);
			break; /* End case 'type2': */

		case 'type3':
			$perfdata_folder = $performancedatatool_folderlocation;
			$perfdata_folder_contents = new RecursiveIteratorIterator(new RecursiveDirectoryIterator($perfdata_folder), RecursiveIteratorIterator::SELF_FIRST);
			break; /* End case 'type3': */
		} /* End switch ($performancedatatool_foldertype) { */
	
	//print_r('<br />perfdata_folder_contents<br />');
	//print_r($perfdata_folder_contents);
	//print_r('<br />');
	
	/* Define current_item_counter */
	$current_item_counter = 0;
	
	/* Define all_performance_files array */
	$all_performance_files = '';
	
	/* Loop through each item in the perfdata root folder */
	foreach ($perfdata_folder_contents as $item) {
		$item_flag = 0;
		/* There are some items we don't want */
		if ($item != '.' && $item != '..') {
			
			/* Defining a folder_file variable for filemtime */
			switch ($performancedatatool_foldertype) {
				case 'type0':
				case 'type1':
				case 'type2':
					$item_folder_file = $perfdata_folder . '/' . $item;
					break; /* End case 'type0': and case 'type1': and case 'type2': */

				case 'type3':
					/* There are some items we don't want */
					if (!is_dir($item)) {
						$item_folder_file = $item;
						} /* End if (!is_dir($item)) { */
					else {
						$item_flag = 1;
						} /* End else { */
					break; /* End case 'type3': */
				} /* End switch ($performancedatatool_foldertype) { */

			/* Continue if the flag hasn't been triggered */
			if ($item_flag == 0) {
				//print_r("$item_folder_file<br/>");
				/* Checking if the file's date is within the date filter range */
				if ((filemtime($item_folder_file) < $performancedatatool_date_filter_selected) or ($performancedatatool_date_filter_selected == 'all')) {
					/* Now add the item to the all_performance_files array */
					$all_performance_files[$current_item_counter]['file'] = $item;
					$all_performance_files[$current_item_counter]['lastmodified'] = date ('Y-m-d H:i:s', filemtime($item_folder_file));
					$current_item_counter++;
					} /* End if ((filemtime($item_folder_file) < $performancedatatool_date_filter_selected) or ($performancedatatool_date_filter_selected == 'all')) { */ 
				} /* End if ($item_flag == 0) { */
			} /* End if ($item != '.' && $item != '..') { */
		} /* End foreach ($perfdata_folder_contents as $item) { */
	return $all_performance_files;
	} /* End function get_all_performance_files($performancedatatool_foldername, $performancedatatool_folderlocation, $performancedatatool_foldertype, $performancedatatool_date_filter_selected) { */

	
function draw_table_of_files($table_id, $performancedatatool_foldername, $performancedatatool_folderlocation, $performancedatatool_foldertype, $all_performance_files, $performancedatatool_select_supplied_name) {
	$return_table = '<table id="'.$table_id.'" class="tablesorter">';
	$return_table .= '<thead><tr>';
	
	/* Get the merge_type_selected passed to us */
	$performancedatatool_merge_type_selected = urldecode(grab_request_var('merge_type_selected',false));

	/* Determining if we need to provide a checkbox or radio column */
	switch ($performancedatatool_select_supplied_name) {
		case 'delete':
			$return_table .= '<th width="20" onclick="performancedatatoolToggleCheckbox(\'delete\')"><input type="checkbox" id="delete"></th>';
			break; /* End case 'delete': */
		
		case 'merge-source':
		case 'merge-destination':
			/* Radio column only required for specific merge list */
			if ($performancedatatool_merge_type_selected == 'specific') {
				$return_table .= '<th width="20"></th>';
				} /* End if ($performancedatatool_merge_type_selected == 'specific') { */
			break; /* End case 'merge-source': 'merge-destination': */
		} /* End switch ($performancedatatool_select_supplied_name) { */
	
	$return_table .= '<th>File</th>     <th>Last Modified</th></tr></thead>';
	
	foreach ($all_performance_files as $item) {
			//print_r("foldername: $performancedatatool_foldername<br/>");
			//print_r("folderlocation: $performancedatatool_folderlocation<br/>");
			//print_r("foldertype: $performancedatatool_foldertype<br/>");
			//print_r("filename: " . $item['file'] . "<br/>");
			//print_r("filename: $item <br/>");
			
		$performancedatatool_item_file_extension = pathinfo($item['file'], PATHINFO_EXTENSION);
		
		if ($performancedatatool_item_file_extension == 'xml') {
			switch ($performancedatatool_select_supplied_name) {
				case 'delete':
					$performancedatatool_create_row = 'yes';
					break; /* End case 'delete': */
				
				case 'merge-source':
				case 'merge-destination':
					$performancedatatool_create_row = 'no';
					break; /* End case 'merge-source': 'merge-destination': */
				} /* End switch ($performancedatatool_select_supplied_name) { */
			} /* End if ($performancedatatool_item_file_extension == 'xml') { */
		else {
			$performancedatatool_create_row = 'yes';
			} /* End else { */
		
		if ($performancedatatool_create_row == 'yes') {
			/* Increment file_counter */
			GLOBAL $file_counter;
			$file_counter++;
			$item_array = array(
				'foldername' => $performancedatatool_foldername,
				'folderlocation' => $performancedatatool_folderlocation,
				'foldertype' => $performancedatatool_foldertype,
				'filename' => (string)$item['file'],
				);
			
			$return_table .= '<tr>';
			/* Determining if we need to provide a checkbox or radio column */
			switch ($performancedatatool_select_supplied_name) {
				case 'delete':
					$return_table .= '<td><input type="checkbox" name="'.urlencode(json_encode($item_array)).'" id="'.urlencode(json_encode($item_array)).'" class="performancedatatool-checkbox" value="'.urlencode(json_encode($item_array)).'"></td>';
					break; /* End case 'delete': */
				
				
				case (preg_match('/^merge/', $performancedatatool_select_supplied_name) ? true : false) :
					/* Radio only required for specific merge list */
					if ($performancedatatool_merge_type_selected == 'specific') {
						/* First create the radio_value */
						switch ($performancedatatool_foldertype) {
							case 'type0':
								$radio_value = urlencode('/usr/local/nagios/share/perfdata/'.$performancedatatool_foldername.'/'.$item['file']);
								break; /* End case 'type0': */
							
							case 'type1':
								$radio_value = urlencode($performancedatatool_folderlocation.'/'.$performancedatatool_foldername.'/'.$item['file']);
								break; /* End case 'type1': */
							
							case 'type2':
								$radio_value = urlencode($performancedatatool_folderlocation.'/'.$item['file']);
								break; /* End case 'type2': */

							case 'type3':
								$radio_value = urlencode($item['file']);
								break; /* End case 'type3': */
							} /* End switch ($performancedatatool_foldertype) { */
						
						/* Now use the radio_value */
						switch ($performancedatatool_select_supplied_name) {
							case 'merge-source':
								$return_table .= '<td><input type="radio" name="merge_source" id="id_merge_source" value="'.$radio_value.'"></td>';
								break; /* End case 'merge-source': */
							
							case 'merge-destination':
								$return_table .= '<td><input type="radio" name="merge_destination" id="id_merge_destination" value="'.$radio_value.'"></td>';
								break; /* End case 'merge-destination': */						
							} /* End switch ($performancedatatool_select_supplied_name) { */
						} /* End if ($performancedatatool_merge_type_selected == 'specific') { */
					break; /* End case (pregmatch('/^merge/', $performancedatatool_select_supplied_name) ? true : false) : */	
				} /* End switch ($performancedatatool_select_supplied_name) { */
			
			/* Determine if this is an XML file */
			if ($performancedatatool_item_file_extension == 'xml') {
				/* Only provide an link to the XML file if the user is an admin */
				if(is_admin() == true) {
					$return_table .= '<td id="'.urlencode(json_encode($item_array)).'" class="item_click" style="cursor: pointer">'.$item['file'].'</td>	<td>'.$item['lastmodified'].'</td>';	
					} /* End if(is_admin() == true) { */
				else {
					$return_table .= '<td id="'.urlencode(json_encode($item_array)).'">'.$item['file'].'</td>	<td>'.$item['lastmodified'].'</td>';
					} /* End else { */
				} /* End if ($performancedatatool_item_file_extension == 'xml') { */
			else {
				/* This is and RRD file so provide a link */
				$return_table .= '<td id="'.urlencode(json_encode($item_array)).'" class="item_click" style="cursor: pointer">'.$item['file'].'</td>	<td>'.$item['lastmodified'].'</td>';	
				} /* End else { */
			$return_table .= '</tr>';
			} /* End if ($performancedatatool_create_row == 'yes') { */
		} /* End foreach ($all_performance_files as $item) { */
	
	$return_table .= '</table>';
	return $return_table;
	} /* End function draw_table_of_files($table_id, $performancedatatool_foldername, $performancedatatool_folderlocation, $all_performance_files, $performancedatatool_select_supplied_name) { */


function determine_date_filter_value($performancedatatool_date_filter) {
	switch ($performancedatatool_date_filter) {
		case "all":
		default:
			$performancedatatool_date_filter_value = "all";
			return $performancedatatool_date_filter_value;
			break; /* End case "all": */

		case "1m":
			$performancedatatool_date_filter_value = time() - (30.4375 * 24 * 60 * 60);
			return $performancedatatool_date_filter_value;
			break; /* End case "1m": */

		case "3m":
			$performancedatatool_date_filter_value = time() - (3 * 30.4375 * 24 * 60 * 60);
			return $performancedatatool_date_filter_value;
			break; /* End case "3m": */

		case "6m":
			$performancedatatool_date_filter_value = time() - (6 * 30.4375 * 24 * 60 * 60);
			return $performancedatatool_date_filter_value;
			break; /* End case "6m": */

		case "9m":
			$performancedatatool_date_filter_value = time() - (9 * 30.4375 * 24 * 60 * 60);
			return $performancedatatool_date_filter_value;
			break; /* End case "9m": */

		case "12m":
			$performancedatatool_date_filter_value = time() - (12 * 30.4375 * 24 * 60 * 60);
			return $performancedatatool_date_filter_value;
			break; /* End case "12m": */

		case "15m":
			$performancedatatool_date_filter_value = time() - (15 * 30.4375 * 24 * 60 * 60);
			return $performancedatatool_date_filter_value;
			break; /* End case "15m": */
		
		case "18m":
			$performancedatatool_date_filter_value = time() - (18 * 30.4375 * 24 * 60 * 60);
			return $performancedatatool_date_filter_value;
			break; /* End case "18m": */

		case "21m":
			$performancedatatool_date_filter_value = time() - (21 * 30.4375 * 24 * 60 * 60);
			return $performancedatatool_date_filter_value;
			break; /* End case "21m": */

		case "24m":
			$performancedatatool_date_filter_value = time() - (24 * 30.4375 * 24 * 60 * 60);
			return $performancedatatool_date_filter_value;
			break; /* End case "24m": */
		} /* End switch ($performancedatatool_date_filter_) { */
	} /* End function determine_date_filter_value($performancedatatool_date_filter) { */
