<?php  
// performance_data_tool_misc COMPONENT
//
// Copyright 2016-05-05 Troy Lea aka Box293
//

require_once(dirname(__FILE__).'/../../common.inc.php');

// initialization stuff
pre_init();
// start session
init_session();
// grab GET or POST variables 
grab_request_vars();
// check prereqs
check_prereqs();
// check authentication
check_authentication(false);


/* Get the request passed to us */
$performancedatatool_request = grab_request_var('request',false);

/* Process the request */
switch ($performancedatatool_request) {
	case 'structure-folders':
		/* Get the merge_folder_location passed to us */
		$merge_folder_location = grab_request_var('merge_folder_location',false);
		/* Get all the perfdata folders */
		$perfdata_folders = get_all_merge_structure_performance_folders($merge_folder_location);
		print urlencode(json_encode($perfdata_folders));
		break; /* End case 'structure-folders': */
	
	case 'structure-file-match':
		/* Get the match_type passed to us */
		$match_type =grab_request_var('match_type',false);
		/* Get the source_location passed to us */
		$source_location = urldecode(grab_request_var('source_location',false));
		/* Get the destination_location passed to us */
		$destination_location = urldecode(grab_request_var('destination_location',false));
		/* See if any files in the source and destination match */
		$matched_perfdata_files = match_performance_files($match_type, $source_location, $destination_location);
		print urlencode(json_encode($matched_perfdata_files));
		break; /* End case 'structure-file-match': */
	
	default:
		/* All other functions build html content */
		/* Build the HTML content */
		$html = performancedatatool_misc($performancedatatool_request);
		print $html; 
		break; /* End default: */
	} /* End switch ($performancedatatool_request) { */


/* FUNCTIONS */

function performancedatatool_misc($performancedatatool_request) {
	$html = '';
	
	/* Perform the request */
	switch ($performancedatatool_request) {
		case 'delete':
			$html .= '<hr>';
			$html .= draw_select_of_actions($performancedatatool_request);
			break; /* End case 'delete': */
		
		case 'host-select':
			/* Get the type passed to us */
			$performancedatatool_type = grab_request_var('type',false);
			/* Get all the host perfdata folders */
			$all_host_folders = get_all_performance_folders($performancedatatool_type);
			/* Draw the select of host folders */
			$html .= draw_select_of_hosts($all_host_folders, $performancedatatool_type);
			break; /* End case 'host-select': */
		
		case 'structure-select':
			/* Get the type passed to us */
			$performancedatatool_type = grab_request_var('type',false);
			
			switch ($performancedatatool_type) {
				case 'merge-source':
					/* Get all the custom structure folders */
					$all_custom_structure_folders = get_all_custom_structure_folders();
					/* Draw the select of custom structure folders */
					$html .= draw_select_of_custom_structure_folders($all_custom_structure_folders, $performancedatatool_type);
					break; /* End case 'merge-source': */
				
				case 'merge-destination':
					/* Draw the select of the destination perfdata folder */
					$html .= '
						<select name="perfdata_structure_folders_merge-destination" id="id_perfdata_structure_folders_merge-destination" title="The default location of the Nagios XI perfdata folder containing sub folders of performance data files">
							<option value="'.urlencode(json_encode('/usr/local/nagios/share/perfdata')).'">/usr/local/nagios/share/perfdata</option>
						</select>
						';
					break; /* End case 'merge-destination': */
				} /* End switch ($performancedatatool_type) */		
			break; /* End case 'structure-select': */
		
		case 'merge_submit_button':
			$html .= '<div class="performancedatatool-spacer15"> </div>';
			$html .= '<input type="button" onclick="performancedatatool_perform_merge()" value="Perform Merge">';
			break; /* End case 'merge_submit_button': */
		
		case 'merge_action_list':
			/* Get the merge_type_selected passed to us */
			$performancedatatool_merge_type_selected = grab_request_var('merge_type_selected',false);
			
			$html .= draw_select_of_actions($performancedatatool_merge_type_selected);
			break; /* End case 'merge_action_list': */
		
		case 'progress':
			/* Get the action passed to us */
			$performancedatatool_progress_action = grab_request_var('action',false);
			/* Get the current_item passed to us */
			$performancedatatool_progress_current_item = grab_request_var('current_item',false);
			/* Create the HTML */
			switch ($performancedatatool_progress_action) {
				case 'update':
					/* Get the total_items passed to us */
					$performancedatatool_progress_total_items = grab_request_var('total_items',false);
					$html .= '
						Processing item '.$performancedatatool_progress_current_item.' / '.$performancedatatool_progress_total_items.'
						';
					break; /* End case 'update': */
				
				case 'finished':
					if ($performancedatatool_progress_current_item > 1) {
						$item_word = 'items';
						} /* End if ($performancedatatool_progress_current_item > 1) { */
					else {
						$item_word = 'item';
						} /* End else { */
					$html .= '
						Processed '.$performancedatatool_progress_current_item.' '.$item_word.'
						';
					break; /* End case 'finished': */
				} /* End switch ($performancedatatool_progress_action) { */
			break; /* End case 'progress': */
		
		case 'throbber':
			/* Get the id passed to us */
			$performancedatatool_throbber_id = grab_request_var('id',false);
			switch ($performancedatatool_throbber_id) {
				case 'specific':
				case 'folder':
				case 'structure':
				case 'delete_selected_items':
				case 'delete_folder':
					$performancedatatool_throbber_div_id = 'performancedatatool-'.$performancedatatool_request.'-'.$performancedatatool_throbber_id;
					$performancedatatool_finished_div_id = 'performancedatatool-finished-'.$performancedatatool_throbber_id;
					$performancedatatool_progress_div_id = 'performancedatatool-progress-'.$performancedatatool_throbber_id;
					$performancedatatool_content_div_id = 'performancedatatool-content-'.$performancedatatool_throbber_id;
					$html .= '
						<div id="'.$performancedatatool_throbber_div_id.'">
							<h3>Please wait while your request is processed</h3>
							'.get_throbber_html().'
							<br /><br />
						</div>
						<div id="'.$performancedatatool_finished_div_id.'" style="display:none">
							<h3>Finished request, check results below</h3>
						</div>
						<div id="'.$performancedatatool_progress_div_id.'">
						</div>
						<div id="'.$performancedatatool_content_div_id.'">
						</div>
						';
					break; /* End case 'specific': case 'folder': case 'structure': case 'delete_selected_items': case 'delete_folder': */
				} /* End switch ($performancedatatool_throbber_id) { */
			break; /* End case 'throbber': */
		
		} /* End switch ($performancedatatool_misc) { */
	
	return $html; 
	} /* End function performancedatatool_misc($performancedatatool_request) { */


function get_all_performance_folders($performancedatatool_type) {
	//print_r('<br />performancedatatool_type: ' .$performancedatatool_type. '<br />');

	/* Define the perfdata root folder */
	$perfdata_root    = '../../../../../nagios/share/perfdata';
	/* Get all items in the perfdata root folder */
	$perfdata_root_folders_all = scandir($perfdata_root);
	
	//print_r('<br />perfdata_root_folders_all<br />');
	//print_r($perfdata_root_folders_all);
	//print_r('<br />');
	
	/* Define all_host_folders array */
	$all_host_folders = '';
	
	/* Define current folder counter */
	$current_folder_counter = 0;

	if (($performancedatatool_type != 'merge-source') && ($performancedatatool_type != 'merge-destination')) {
		/* Add the top level folder to the all_host_folders array */
		$all_host_folders[$current_folder_counter]['folder_name'] = 'All_Nagios_XI_Performance_Data_Files_For_All_Hosts';
		$all_host_folders[$current_folder_counter]['folder_location'] = $perfdata_root;
		$all_host_folders[$current_folder_counter]['folder_type'] = 'type3';
		$current_folder_counter++;
		} /* End if (($performancedatatool_type != 'merge-source') && ($performancedatatool_type != 'merge-destination')) { */
	
	/* Loop through each folder in the perfdata root folder */
	foreach ($perfdata_root_folders_all as $item) {
		/* There are some items we don't want */
		if ($item != '.' && $item != '..' && $item != '.pnp-internal') {
			/* Now add them to the all_host_folders array */
			$all_host_folders[$current_folder_counter]['folder_name'] = $item;
			$all_host_folders[$current_folder_counter]['folder_location'] = $perfdata_root;
			$all_host_folders[$current_folder_counter]['folder_type'] = 'type0';
			$current_folder_counter++;
			} /* End if ($item != '.' && $item != '..' && $item != '.pnp-internal') { */
		} /* End foreach ($perfdata_root_folders_all as $item) { */
	
	
	/* Custom Defined Folders section */
	$settings_raw = get_option('performancedatatool_component_options');
	if($settings_raw == '') {
		/* There are currently no settings so define an array */
		$settings = array();
		} /* End if($settings_raw == '') { */
	else {
		/* Settings are defined so unserialize them */
		$settings = unserialize($settings_raw);
		} /* End else { */

	/* Get the folders_list */
	$folders_list = grab_array_var($settings,'folders_list','');
	
	/* Check to see if any custom folders have been defined */
	if (!empty($folders_list)) {
		foreach ($folders_list as $nested_array) {
			if (($performancedatatool_type != 'merge-source') && ($performancedatatool_type != 'merge-destination')) {
				if ($nested_array[1] == 'type1') {
					/* Add the top level folder to the all_host_folders array */
					$all_host_folders[$current_folder_counter]['folder_name'] = 'All_Performance_Data_Files_Under_Custom_Location' . preg_replace('/\//', '_', $nested_array[0]);
					$all_host_folders[$current_folder_counter]['folder_location'] = $nested_array[0];
					$all_host_folders[$current_folder_counter]['folder_type'] = 'type3';
					$current_folder_counter++;				
					} /* End if ($nested_array[1] == 'type1') { */
				} /* End if (($performancedatatool_type != 'merge-source') && ($performancedatatool_type != 'merge-destination')) { */

			/* Process the custom folder type */
			switch ($nested_array[1]) {
				case 'type1':
					/* Get all items in the custom folder */
					$custom_folders_all = scandir($nested_array[0]);
					
					/* Loop through each folder in the custom folder */
					foreach ($custom_folders_all as $item) {
						/* There are some items we don't want */
						if ($item != '.' && $item != '..' && $item != '.pnp-internal') {
							/* Now add them to the all_host_folders array */
							$all_host_folders[$current_folder_counter]['folder_name'] = $item;
							$all_host_folders[$current_folder_counter]['folder_location'] = $nested_array[0];
							$all_host_folders[$current_folder_counter]['folder_type'] = 'type1';
							$current_folder_counter++;
							} /* End if ($item != '.' && $item != '..' && $item != '.pnp-internal') { */
						} /* End foreach ($custom_folders_all as $item) { */
					break; /* End case 'type1': */
				
				
				case 'type2':
					/* Now add the folder to the all_host_folders array */
					$folderinfo = pathinfo($nested_array[0]);
					$all_host_folders[$current_folder_counter]['folder_name'] = $folderinfo['basename'];
					$all_host_folders[$current_folder_counter]['folder_location'] = $nested_array[0];
					$all_host_folders[$current_folder_counter]['folder_type'] = 'type2';
					$current_folder_counter++;
					break; /* End case 'type2': */
				} /* End switch ($nested_array[1]) { */
			} /* End foreach ($folders_list as $nested_array) { */
		} /* End if (!empty($folders_list)) { */
	/* Finished Custom Defined Folders section */
	
	
	//print_r('<br />all_host_folders<br />');
	//print_r($all_host_folders);
	//print_r('<br />');
	
	return $all_host_folders;
	} /* End function get_all_performance_folders($performancedatatool_type) { */


function get_all_custom_structure_folders() {
	/* Define all_custom_structure_folders array */
	$all_custom_structure_folders = '';
	
	/* Define current folder counter */
	$current_folder_counter = 0;
	
	$settings_raw = get_option('performancedatatool_component_options');
	if($settings_raw == '') {
		/* There are currently no settings so define an array */
		$settings = array();
		} /* End if($settings_raw == '') { */
	else {
		/* Settings are defined so unserialize them */
		$settings = unserialize($settings_raw);
		} /* End else { */

	/* Get the folders_list */
	$folders_list = grab_array_var($settings,'folders_list','');
	
	/* Check to see if any custom folders have been defined */
	if (!empty($folders_list)) {
		foreach ($folders_list as $nested_array) {
			/* Process the custom folder type */
			switch ($nested_array[1]) {
				case 'type1':
					/* Add it to the all_custom_structure_folders array */
					$all_custom_structure_folders[$current_folder_counter]['folder_name'] = $nested_array[0];
					$all_custom_structure_folders[$current_folder_counter]['folder_location'] = $nested_array[0];
					$all_custom_structure_folders[$current_folder_counter]['folder_type'] = 'type1';
					$current_folder_counter++;
					break; /* End case 'type1': */
				} /* End switch ($nested_array[1]) { */
			} /* End foreach ($folders_list as $nested_array) { */
		} /* End if (!empty($folders_list)) { */
	
	//print_r('<br />all_custom_structure_folders<br />');
	//print_r($all_custom_structure_folders);
	//print_r('<br />');
	
	return $all_custom_structure_folders;
	} /* End function get_all_custom_structure_folders() { */

	
function get_all_merge_structure_performance_folders($merge_folder_location) {
	/* Get all items in the perfdata root folder */
	$merge_folder_location_folders_all = scandir($merge_folder_location);
	
	/* Define all_host_folders array */
	$all_perfdata_folders = '';
	
	/* Define current folder counter */
	$current_folder_counter = 0;
	
	/* Loop through each folder in the perfdata root folder */
	foreach ($merge_folder_location_folders_all as $item) {
		/* There are some items we don't want */
		if ($item != '.' && $item != '..' && $item != '.pnp-internal') {
			/* Now add them to the all_host_folders array */
			$all_perfdata_folders[$current_folder_counter] = $item;
			$current_folder_counter++;
			} /* End if ($item != '.' && $item != '..' && $item != '.pnp-internal') { */
		} /* End foreach ($merge_folder_location_folders_all as $item) { */
	
	return $all_perfdata_folders;
	} /* End get_all_merge_structure_performance_folders($merge_folder_location) { */


function match_performance_files($match_type, $source_location, $destination_location) {
	/* Get all files in the source_location */
	$source_location_files = scandir($source_location);
	/* Get all files in the destination_location */
	$destination_location_files = scandir($destination_location);
	
	/* Define matched_perfdata_files array */
	$matched_perfdata_files = '';
	
	/* Define current file counter */
	$current_file_counter = 0;
	
	/* Loop through each file in the source_location */
	foreach ($source_location_files as $source_file) {
		/* There are some items we don't want */
		if ($source_file != '.' && $source_file != '..') {
			/* Determine source_file extension */
			$source_file_extension = pathinfo($source_file, PATHINFO_EXTENSION);
			if ($source_file_extension == 'rrd') {
				/* Loop through each file in the destination_location */
				foreach ($destination_location_files as $destination_file) {
					/* There are some items we don't want */
					if ($destination_file != '.' && $destination_file != '..') {
						/* Determine destination_file extension */
						$destination_file_extension = pathinfo($destination_file, PATHINFO_EXTENSION);
						if ($destination_file_extension == 'rrd') {
							$files_match = 'no';
							/* Now see if the source_file matches the destination_file */
							switch ($match_type) {
								case 'case-sensitive':
									if ($source_file == $destination_file) {
										$files_match = 'yes';
										} /* End if (source_folder == destination_folder) { */
									break; /* End case 'case-sensitive': */
								
								case 'case-insensitive':
									if (strcasecmp($source_file, $destination_file) == 0) {
										$files_match = 'yes';
										} /* End if (strcasecmp($source_file, $destination_file) == 0) { */
									break; /* End case 'case-sensitive': */
								} /* End switch ($match_type) { */
							/* If they match, add them to the matched_perfdata_files array */
							if ($files_match == 'yes') {
								$matched_perfdata_files[$current_file_counter][0] = $source_location . '/' . $source_file;
								$matched_perfdata_files[$current_file_counter][1] = $destination_location . '/' . $destination_file;
								$current_file_counter++;
								} /* End if ($files_match == 'yes') { */
							} /* End if ($destination_file_extension == 'rrd') { */
						} /* End if ($destination_file != '.' && $destination_file != '..') { */
					} /* End foreach ($destination_location_files as $destination_file) { */
				}	/* End if ($source_file_extension == 'rrd') { */
			} /* End if ($source_file != '.' && $source_file != '..') { */
		} /* End foreach ($source_location_files as $source_file) { */
	
	return $matched_perfdata_files;
	} /* End function match_performance_files($match_type, $source_location, $destination_location) { */
	
	
function draw_select_of_hosts($all_host_folders, $select_supplied_name) {
	$select_name = 'all_host_folders_' . $select_supplied_name;
	$select_id = 'id_all_host_folders_' . $select_supplied_name;
	$return_select = '
		<select name="'.$select_name.'" id="'.$select_id.'" title="A list of folders containing host performance data files" onChange="performancedatatool_draw_table(\''.$select_supplied_name.'\')">
			<option value=""></option>
		';
	foreach ($all_host_folders as $item_array) {
		//print_r('<br />');
		//print_r($item_array);
		//print_r('<br />');
		switch ($item_array['folder_type']) {
			case 'type0':
				$return_select .= '<option value="'.urlencode(json_encode($item_array)).'">'.$item_array['folder_name'].'</option>';
				break; /* End case 'type0': */
			
			case 'type1':
				if (strrpos($item_array['folder_name'], 'All_Performance_Data_Files_Under_', strlen($item_array['folder_name'])) === false) {
					$return_select .= '<option value="'.urlencode(json_encode($item_array)).'">'.$item_array['folder_name'].'</option>';
					} /* End if (strrpos($item_array['folder_name'], 'All_Performance_Data_Files_Under_', strlen($item_array['folder_name'])) === false) { */
				else {
					$return_select .= '<option value="'.urlencode(json_encode($item_array)).'">'.$item_array['folder_location'].'/'.$item_array['folder_name'].'</option>';
					} /* End else { */
				break; /* End case 'type1': */
			
			case 'type2':
				$return_select .= '<option value="'.urlencode(json_encode($item_array)).'">'.$item_array['folder_location'].'</option>';
				break; /* End case 'type2': */

			case 'type3':
				$return_select .= '<option value="'.urlencode(json_encode($item_array)).'">'.$item_array['folder_name'].'</option>';
				break; /* End case 'type2': */
			} /* End switch ($item_array['folder_type']) { */
		} /* End foreach ($all_host_folders as $item_array) { */
	$return_select .= '</select>';
	return $return_select;
	} /* End function draw_select_of_hosts($all_host_folders, $select_supplied_name) { */


function draw_select_of_custom_structure_folders($all_custom_structure_folders, $select_supplied_name) {
	$select_name = 'all_custom_structure_folders_' . $select_supplied_name;
	$select_id = 'id_all_custom_structure_folders_' . $select_supplied_name;
	$return_select = '
		<select name="'.$select_name.'" id="'.$select_id.'" title="A list of custom folders containing sub folders of performance data files">
			<option value=""></option>
		';
	foreach ($all_custom_structure_folders as $item_array) {
		//print_r('<br />');
		//print_r($item_array);
		//print_r('<br />');
		$return_select .= '<option value="'.urlencode(json_encode($item_array)).'">'.$item_array['folder_location'].'</option>';
		} /* End foreach ($all_custom_structure_folders as $item_array) { */
	$return_select .= '</select>';
	return $return_select;
	} /* End function draw_select_of_custom_structure_folders($all_custom_structure_folders, $select_supplied_name) { */


function draw_select_of_actions($action) {
	$action_name = 'action_' . $action;
	$action_id = 'id_action_' . $action;
	
	$return_html = '<div class="performancedatatool-spacer10"> </div>';
	$return_html .= '<input type="button" onclick="performancedatatool_perform_action(\''.$action.'\')" value="Perform Action">';
	
	switch ($action) {
		case 'delete':
			$return_html .= '
				<select name="'.$action_name.'" id="'.$action_id.'" title="Select an action to perform">
					<option value="" selected></option>
					<option value="delete_selected_items">Delete file(s) selected above</option>
					<option value="delete_folder">Delete FOLDER and ALL file(s) above</option>
				</select>';
			break; /* End case 'delete': */
		
		case 'merge_list_specific':
			$return_html .= '
				<select name="'.$action_name.'" id="'.$action_id.'" title="Select an action to perform">
					<option value="add" selected>Add SOURCE and DESTINATION to Merge List</option>
					<option value="remove">REMOVE selection(s) FROM Merge List</option>
					<option value="clear">CLEAR Merge List</option>
				</select>';
			break; /* End case 'merge': */
		
		case 'merge_list_folder':
			$return_html .= '
				<select name="'.$action_name.'" id="'.$action_id.'" title="Select an action to perform">
					<option value="add-folder" selected>Match files in SOURCE folder to DESTINATION folder and add to Merge List</option>
					<option value="remove">REMOVE selection(s) FROM Merge List</option>
					<option value="clear">CLEAR Merge List</option>
				</select>';
			break; /* End case 'folder': */
		
		case 'merge_list_structure':
			$return_html .= '
				<select name="'.$action_name.'" id="'.$action_id.'" title="Select an action to perform">
					<option value="add-structure" selected>Match files in folder structure in SOURCE folder to DESTINATION folder and add to Merge List</option>
					<option value="remove">REMOVE selection(s) FROM Merge List</option>
					<option value="clear">CLEAR Merge List</option>
				</select>';
			break; /* End case 'folder': */
		} /* End switch ($action) { */
	return $return_html;
	} /* End function perform_action($action) { */
